<?php
class FunnelKit{
	var $current_post = array();
	var $current_page = '';
	var $optin_form = '';
	var $settings = array();
	
	
	
	function __construct(){
		add_action('init', array($this,'funnelkit_activate_au'));
		add_action('init', array($this, 'funnelkit_init'));
		if($_GET['funnelkit_preview'] == "true") {
			ob_start();
		}
		if(is_admin() and $this->do_init() AND $_GET['funnelkit_preview'] != "true"){
			add_action('admin_menu', array($this, 'add_funnelkit_admin_menu'));
			$this->check_license();
			if (isset($_GET['page'])) {
				if($_GET['page']=='funnelkit_edit'){
					$this->funnelkit_post_events();
					add_action('admin_enqueue_scripts', array($this, 'preload_funnelkit_styles'));
					add_action('admin_enqueue_scripts', array($this, 'preload_funnelkit_scripts'));
					if(!isset($this->settings['mode'])){
						add_action('admin_enqueue_scripts', array($this, 'preload_funnelkit_settings_styles'));
					}
				}elseif($_GET['page']=='funnelkit_settings' or $_GET['page']=='funnelkit_license'){
					
					add_action('admin_enqueue_scripts', array($this, 'preload_funnelkit_settings_styles'));
				}elseif($_GET['page']=='funnelkit'){
					if(!isset($this->settings['mode'])){
						add_action('admin_enqueue_scripts', array($this, 'preload_funnelkit_settings_styles'));
					}else{
						add_action('admin_enqueue_scripts', array($this, 'preload_funnelkit_list_styles'));
					}
				}
			}
		}else{
			if($this->do_init()){
				wp_enqueue_script( 'wp-funnelkit-frontend-js' );
				add_action('get_header', array($this, 'funnelkit_frontend_head'), 0);
				add_action('get_header', array($this, 'funnelkit_frontend_loaded'), 1);
			}
		}
	}
	
	
	function funnelkit_frontend_head(){
		global $wp;
		if($wp->query_vars['post_type']==='funnelkit' OR $_GET['funnelkit_preview'] == "true" OR defined("FUNNELKIT_OVERIDE")){
			ob_start();
		}
	}
	
	function funnelkit_frontend_loaded(){
		global $wp;
		if($wp->query_vars['post_type']==='funnelkit' OR $_GET['funnelkit_preview'] == "true" OR defined("FUNNELKIT_OVERIDE")){
			$content = ob_get_contents();
			$header_styles .= "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\">\n";
			$header_styles .= "<html xmlns=\"http://www.w3.org/1999/xhtml\" lang=\"en-US\"> \n";
			$header_styles .= "<head profile=\"http://gmpg.org/xfn/11\">\n";
			$header_styles .= "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" />\n";
			$header_styles .= "<meta http-equiv=\"X-UA-Compatible\" content=\"IE=7\" />\n";
			$header_styles .= "<title></title>\n";
			$header_styles .= "<link rel='stylesheet' id='open-sans-css'  href='//fonts.googleapis.com/css?family=Open+Sans%3A300italic%2C400italic%2C600italic%2C300%2C400%2C600&#038;subset=latin%2Clatin-ext&#038;ver=3.8' type='text/css' media='all' />\n";
			$header_styles .= "<link rel='stylesheet' id='twentythirteen-fonts-css'  href='//fonts.googleapis.com/css?family=Source+Sans+Pro%3A300%2C400%2C700%2C300italic%2C400italic%2C700italic%7CBitter%3A400%2C700&#038;subset=latin%2Clatin-ext' type='text/css' media='all' />\n";
			
			if(isset($_GET['folder'])) {
				if(!is_dir(FUNNELKIT_ABSPATH."/export/{$_GET['folder']}/")) {
					mkdir(FUNNELKIT_ABSPATH."/export/{$_GET['folder']}/");
				}
				//export js
				if(!is_dir(FUNNELKIT_ABSPATH."/export/{$_GET['folder']}/js/")) {
					mkdir(FUNNELKIT_ABSPATH."/export/{$_GET['folder']}/js/");
				}
				
				$fh = fopen(FUNNELKIT_ABSPATH."/export/{$_GET['folder']}/js/jquery.js","w");
				fwrite($fh,$this->funnelkit_get(includes_url()."js/jquery/jquery.js?ver=1.10.2"));
				fclose($fh);
				
				$fh = fopen(FUNNELKIT_ABSPATH."/export/{$_GET['folder']}/js/jquery-migrate.min.js","w");
				fwrite($fh,$this->funnelkit_get(includes_url()."js/jquery/jquery-migrate.min.js?ver=1.2.1"));
				fclose($fh);
				
				$fh = fopen(FUNNELKIT_ABSPATH."/export/{$_GET['folder']}/js/frontend.js","w");
				fwrite($fh,$this->funnelkit_get(FUNNELKIT_GUI_RELPATH."/js/frontend.js"));
				fclose($fh);
				
				//export CSS
				if(!is_dir(FUNNELKIT_ABSPATH."/export/{$_GET['folder']}/css/")) {
					mkdir(FUNNELKIT_ABSPATH."/export/{$_GET['folder']}/css/");
				}
				
				$fh = fopen(FUNNELKIT_ABSPATH."/export/{$_GET['folder']}/css/frontend.css","w");
				fwrite($fh,$this->funnelkit_get(FUNNELKIT_GUI_RELPATH."/css/frontend.css"));
				fclose($fh);
				
				$header_styles .= "<script type='text/javascript' src='js/jquery.js?ver=1.10.2'></script>\n";
				$header_styles .= "<script type='text/javascript' src='js/jquery-migrate.min.js?ver=1.2.1'></script>\n";
				$header_styles .= "<script type='text/javascript' src='js/frontend.js'></script>\n";
				$header_styles .= "<link rel='stylesheet' id='funnelkit-style-css'  href='css/frontend.css' type='text/css' media='all' />\n";
			} else {
				$header_styles .= "<script type='text/javascript' src='".includes_url()."js/jquery/jquery.js?ver=1.10.2'></script>\n";
				$header_styles .= "<script type='text/javascript' src='".includes_url()."js/jquery/jquery-migrate.min.js?ver=1.2.1'></script>\n";
				$header_styles .= "<script type='text/javascript' src='".FUNNELKIT_GUI_RELPATH."/js/frontend.js'></script>\n";
				$header_styles .= "<link rel='stylesheet' id='funnelkit-style-css'  href='".FUNNELKIT_GUI_RELPATH."/css/frontend.css' type='text/css' media='all' />\n";
				if (class_exists('ViberPro_class')){
					$header_styles .= "<script type='text/javascript' src='".admin_url('admin-ajax.php'). "?viberjs=&i= " . get_the_ID() . "'></script>\n";
			    }
			}
			
			$header_content = $page_content.$header_styles.'<body class="funnelkit-page">';
			echo $header_content;
			if($_GET['funnelkit_preview'] == "true") {
				$this->render_page_content(0,$_POST);
			} else {
				$this->render_page_content(get_the_ID());
			}
			
			echo $funnelkit_conent;
			
			$footer_content = '</body></html>';
			echo $footer_content;
			die();
		}
	}
	function get_geo_info($ip) {
		$curl = curl_init();
		curl_setopt_array($curl, array(
		    CURLOPT_RETURNTRANSFER => 1,
		    CURLOPT_URL => 'http://freegeoip.net/json/'.$ip,
		    CURLOPT_CONNECTTIMEOUT => 5,
		    CURLOPT_TIMEOUT => 5
		));
		$resp = curl_exec($curl);
		curl_close($curl);
		$data = @json_decode($resp);
		if ($data === null && json_last_error() !== JSON_ERROR_NONE) {
		    //fallback
		    
		    $curl = curl_init();
			curl_setopt_array($curl, array(
			    CURLOPT_RETURNTRANSFER => 1,
			    CURLOPT_URL => 'http://api.hostip.info/get_json.php?ip='.$ip.'&position=true',
			    CURLOPT_CONNECTTIMEOUT => 5,
			    CURLOPT_TIMEOUT => 5
			));
			$resp = curl_exec($curl);
			curl_close($curl);
			$data = @json_decode($resp);
		    if ($data === null && json_last_error() !== JSON_ERROR_NONE) {
		    	return false;
		    } else {
		    	//format the JSON to match the other one here
				$data->region_name = $data->city;
				return $data;
		    }
		} else {
			return $data;
		}
	}
	function funnelkit_get($url) {
		if(function_exists('curl_version')) {
			$curl = curl_init();
			curl_setopt_array($curl, array(
			    CURLOPT_RETURNTRANSFER => 1,
			    CURLOPT_URL => $url
			));
			$resp = curl_exec($curl);
			curl_close($curl);
			return $resp;
		} else {
			return file_get_contents($url);
		}
	}
	function render_page_content($post_id,$post_override = false){
		if(is_array($post_override)) {
			//AJAX preview, produce $funnelkit_info out of POST
			$funnelkit_info[0] = $post_override;
			foreach($funnelkit_info[0] as $key => $val) {
				$funnelkit_info[0][$key] = stripcslashes($val);
			}
		} else {
			$funnelkit_info = get_post_meta($post_id, 'funnelkit-data');
		}
		$ip = $_SERVER['X_FORWARDED_FOR'];
		if ($ip==''){
			$ip = $_SERVER['REMOTE_ADDR'];
		}
		if($funnelkit_info[0]['funnelkit-disable-geo'] != "on") {
			$user_info = $this->get_geo_info($ip);
		}
		
		
		
		/*Render optin_form for future use*/
		$this->render_optin_form($funnelkit_info[0]);
		
		$funnelkit_scripts = '';
		$funnelkit_background_styles = '';
		$funnelkit_content_styles = '';
		
		$funnelkit_callouts_styles = '';
		$funnelkit_callouts_content = '';
		
		$funnelkit_exit_styles = '';
		$funnelkit_exit_content = '';
		$funnelkit_old_exit_script = '';
		
		/*Background*/
		
		
		if($funnelkit_info[0]['funnelkit-background-type']==='image'){
			
			if($funnelkit_info[0]['funnelkit-background-image-pin-fill']=='on'){
				$funnelkit_background_styles .= 'background-color: #'.$funnelkit_info[0]['funnelkit-background-image-pin-fill-color'].';';
			}
			if(isset($_GET['folder'])) {
				$new_img = $this->export_image($funnelkit_info[0]['funnelkit-background-image-url']);
				$funnelkit_background_styles .= 'background-image: url(\''.$new_img.'\');';
			} else {
				$funnelkit_background_styles .= 'background-image: url(\''.$funnelkit_info[0]['funnelkit-background-image-url'].'\');';
			}
			
			if($funnelkit_info[0]['funnelkit-background-image-repeat-x']=='on' and $funnelkit_info[0]['funnelkit-background-image-repeat-y']){
				$funnelkit_background_styles .= 'background-repeat: repeat;';
			}elseif($funnelkit_info[0]['funnelkit-background-image-repeat-x']=='on'){
				$funnelkit_background_styles .= 'background-repeat: repeat-x;';
			}elseif($funnelkit_info[0]['funnelkit-background-image-repeat-y']=='on'){
				$funnelkit_background_styles .= 'background-repeat: repeat-y;';
			}else{
				$funnelkit_background_styles .= 'background-repeat: no-repeat;';
			}
			if($funnelkit_info[0]['funnelkit-background-image-pin-background']=='on'){
				$funnelkit_background_styles .= 'position: fixed;';
			}
			if($funnelkit_info[0]['funnelkit-background-image-strech']=='on'){
				$funnelkit_background_styles .= 'background-position:center;-webkit-background-size: cover;background-size: cover;';
			}
			$funnelkit_scripts .= 'resizeWrapper();';
		}
		if($funnelkit_info[0]['funnelkit-exit-message-old-enabled'] == "on") {
			$funnelkit_old_exit_script = '<script type="text/javascript">
				var is_asked = false;
				 
				window.onbeforeunload =
				  function (ev) {
				    var e = ev || window.event;
				    window.focus();
				    if (!is_asked){
				      is_asked = true;
				      var showstr = "'.str_replace(array("\r\n", "\r", "\n"), '\n', $this->replace_placeholders($funnelkit_info[0]['funnelkit-exit-message-old-text'],$user_info)).'";
				      if (e) {  //for ie and firefox
				        e.returnValue = showstr;
				      }
				      return showstr; //for safari and chrome
				    }
				  };
				 
				window.onfocus =
				  function (ev){
				    if (is_asked){
				      window.location.href = "'.$funnelkit_info[0]['funnelkit-exit-message-old-link'].'";
				    }
				  }
				jQuery("form").submit(function(){
					is_asked = true;
				});
				jQuery("a").click(function(){
					is_asked = true;
				});
				</script>';
		}
		if(in_array($funnelkit_info[0]['funnelkit-background-type'], array('map-satellite', 'map-road', 'map-satellite-road'))){
			//echo "<pre>";
			//print_r($funnelkit_info);
			//exit;
			if($funnelkit_info[0]['funnelkit-background-map-type']=='dynamic'){
				//Scoding edits
				$geocoding = $this->funnelkit_get("http://maps.google.com/maps/api/geocode/json?address=".urlencode($user_info->region_name.', '. $user_info->city.', '.$user_info->country_name)."&sensor=false");
				$geocoding = json_decode($geocoding);
				if(is_object($geocoding)) {
					if(is_object($geocoding->results[0]->geometry->bounds->northeast)) {
						$bounds = $geocoding->results[0]->geometry->bounds->northeast;
						$lat = $bounds->lat-0.12;
						$lng = $bounds->lng-0.45;
						$pin = $lat.",".$lng;
					} else {
						//handle fail
					}
				} else {
					//handle fail
				}
			}else{
				if(strpos($funnelkit_info[0]['funnelkit-background-map-pin-url'], "http") !== FALSE) {
					//extract data from URL
					$query = parse_url($funnelkit_info[0]['funnelkit-background-map-pin-url'], PHP_URL_QUERY);
					parse_str($query, $params);
					//sspn , sll
					if(isset($params['z'])) {
						$zoom = $params['z'];
					}
					$cords = explode(",",$params['ll']);
					$lat = $cords[0];
					$lng = $cords[1];
				} else {
					$geocoding = $this->funnelkit_get("http://maps.google.com/maps/api/geocode/json?address=".urlencode($funnelkit_info[0]['funnelkit-background-map-pin-url'])."&sensor=false");
					$geocoding = json_decode($geocoding);
					if(is_object($geocoding)) {
						if(is_object($geocoding->results[0]->geometry->bounds->northeast)) {
							$bounds = $geocoding->results[0]->geometry->bounds->northeast;
							$lat = $bounds->lat+0.1;
							$lng = $bounds->lng-0.75;
							$pin = $lat.",".$lng;
						} else {
							//handle fail
						}
					} else {
						//handle fail
					}
				}
				$pin = $lat.",".$lng;
			}
			$map_type = '&maptype=satellite';
			if($funnelkit_info[0]['funnelkit-background-type']=='map-satellite-road'){
				$map_type = '&maptype=hybrid';
			}
			if($funnelkit_info[0]['funnelkit-background-type']=='map-road'){
				$map_type = '&maptype=roadmap';
			}
			//
			if(!isset($zoom)) $zoom = 10;		
			$funnelkit_background_styles .= 'background-image: url(\'http://maps.googleapis.com/maps/api/staticmap?center='.$pin.'&zoom='.$zoom.'&size=640x640&sensor=true&scale=2'.$map_type.'\');';
			$funnelkit_background_styles .= '-webkit-background-size: cover;background-size: cover;';
			$funnelkit_background_styles .= 'position: fixed;';
			$funnelkit_background_styles .= 'background-repeat: no-repeat;';
			$funnelkit_background_styles .= 'background-position: center center;';
			$funnelkit_background_styles .= 'opacity: 70%;';
		}

		
		if($funnelkit_info[0]['funnelkit-background-type']==='color-solid'){
			$funnelkit_background_styles .= 'background-color: #'.$funnelkit_info[0]['funnelkit-background-color-solid'].';';
			$funnelkit_background_styles .= 'position: fixed;';
			
		}
		
		if($funnelkit_info[0]['funnelkit-background-type']==='color-gradient'){
			$funnelkit_background_styles .=	"background: #".$funnelkit_info[0]['funnelkit-background-gradient-color-top'].";";
			$funnelkit_background_styles .=	"background: linear-gradient(to top, #".$funnelkit_info[0]['funnelkit-background-gradient-color-bottom'].", #".$funnelkit_info[0]['funnelkit-background-gradient-color-top'].");";
			$funnelkit_background_styles .= 'position: fixed;';
		}
		
		if($funnelkit_info[0]['funnelkit-background-type']==='video'){
			$funnelkit_background_styles .= 'position: fixed;';
			$loop = 'is_loop = "no-loop",';
			if($funnelkit_info[0]['funnelkit-background-video-mute']=='on'){
				$loop = 'is_loop = "loop",';
			}
			
			$mute = 'is_mute = "no-mute",';
			if($funnelkit_info[0]['funnelkit-background-video-mute']=='on'){
				$mute = 'is_mute = "mute",';
			}
			$ytID = $this->get_youtube_id($funnelkit_info[0]['funnelkit-background-video-url']);
			//end
			$funnelkit_scripts .= 'var w =0, h=0, '.$loop.' '.$mute.' video_id = "'.$ytID.'";renderVideo();';
		}
		
		/*Callouts*/
		if($funnelkit_info[0]['funnelkit-callout-enabled']=='on'){
			$call_pos = '';
			if($funnelkit_info[0]['funnelkit-callout-position']=='top-right'){$call_pos = 'top:0;right:0;';}
			if($funnelkit_info[0]['funnelkit-callout-position']=='top-left'){$call_pos = 'top:0;left:0;';}
			if($funnelkit_info[0]['funnelkit-callout-position']=='bottom-right'){$call_pos = 'bottom:0;right:0;';}
			if($funnelkit_info[0]['funnelkit-callout-position']=='bottom-left'){$call_pos = 'bottom:0;left:0;';}
			
			$funnelkit_callouts_styles .= '.funnelkit_callouts{display:inline-block;z-index:2;position:fixed;'.$call_pos.'}';
			$funnelkit_callouts_styles .= '.callout_element{display:inline-block; margin:'.$funnelkit_info[0]['funnelkit-callout-margin'].'px; padding:'.$funnelkit_info[0]['funnelkit-callout-padding'].'px; width:'.$funnelkit_info[0]['funnelkit-callout-width'].'px; background:#'.$funnelkit_info[0]['funnelkit-callout-color'].';display:none;}';
			if($funnelkit_info[0]['funnelkit-callout-round-conners']=='on'){
				$funnelkit_callouts_styles .= '.callout_element{border-radius:5px;}';
			}
			
			if($funnelkit_info[0]['funnelkit-callout-opacity']!=100 and $funnelkit_info[0]['funnelkit-callout-opacity']!=0){
				$layout_opacity = $funnelkit_info[0]['funnelkit-callout-opacity']/100;
				$layput_rgb = $this->hex2rgb($funnelkit_info[0]['funnelkit-callout-color']);
				$funnelkit_callouts_styles .= '.callout_element{background-color:#'.$funnelkit_info[0]['funnelkit-callout-color'].';background-color:rgba('.  implode(',', $layput_rgb).', '.$layout_opacity.');}';
			}
			
			for($i=1; $i<=$funnelkit_info[0]['funnelkit-callout-count']; $i++){
				$funnelkit_callouts_content .= '<div class="callout_element" id="callout_element_'.$i.'" x-data-delay="'.$funnelkit_info[0]['funnelkit-callout-item-delay-'.$i].'">'.nl2br($this->replace_placeholders($funnelkit_info[0]['funnelkit-callout-item-text-'.$i],$user_info)).'</div>';
			}
			$funnelkit_scripts .= 'renderCallouts();';
			
			
		}
		
		

		/*Content*/
		if($funnelkit_info[0]['funnelkit-layout-width']=='fixed-width'){
			$funnelkit_content_styles .= 'width:'.$funnelkit_info[0]['funnelkit-layout-width-fixed'].'px;';
		}else{
			$funnelkit_content_styles .= 'width:100%;';
		}
		
		$funnelkit_content_styles .= 'padding:'.$funnelkit_info[0]['funnelkit-layout-padding'].'px;';
		
		if($funnelkit_info[0]['funnelkit-layout-opacity']!=100 and $funnelkit_info[0]['funnelkit-layout-opacity']!=0){
			$layout_opacity = $funnelkit_info[0]['funnelkit-layout-opacity']/100;
			if($funnelkit_info[0]['funnelkit-container-no-bg'] != "on") {
				$layput_rgb = $this->hex2rgb($funnelkit_info[0]['funnelkit-layout-color']);
				$funnelkit_content_styles .= 'background-color:#'.$funnelkit_info[0]['funnelkit-layout-color'].';';
				$funnelkit_content_styles .= 'background-color:rgba('.  implode(',', $layput_rgb).', '.$layout_opacity.');';
				$funnelkit_content_styles .= 'filter: progid:DXImageTransform.Microsoft.gradient(GradientType=0,startColorstr=\'#'.$funnelkit_info[0]['funnelkit-layout-color'].'\', endColorstr=\'#'.$funnelkit_info[0]['funnelkit-layout-color'].'\');';
				
				
				
			}
		}else{
			if($funnelkit_info[0]['funnelkit-container-no-bg'] != "on") {
				$funnelkit_content_styles .= 'background-color:#'.$funnelkit_info[0]['funnelkit-layout-color'].';';
			}
		}
		
		
		
		
		if($funnelkit_info[0]['funnelkit-layout-border-round']=='on'){
			$funnelkit_content_styles .= 'border-radius: 10px 10px 10px 10px;';
		}
		
		$funnelkit_content_styles .= 'border-width:'.$funnelkit_info[0]['funnelkit-layout-border-size'].'px;';
		$funnelkit_content_styles .= 'border-color:#'.$funnelkit_info[0]['funnelkit-layout-border-color'].';';
		
		if($funnelkit_info[0]['funnelkit-layout-horizontal-position']=='middle'){
			$funnelkit_content_styles .= 'margin:0 auto;';
		}elseif($funnelkit_info[0]['funnelkit-layout-horizontal-position']=='left'){
			$funnelkit_content_styles .= 'margin-left:'.$funnelkit_info[0]['funnelkit-layout-horizontal-position-left'].'%;';
		}else{
			$funnelkit_content_styles .= 'right:'.$funnelkit_info[0]['funnelkit-layout-horizontal-position-right'].'%;';
			$funnelkit_content_styles .= 'float:right;';
		}
		
		
		if($funnelkit_info[0]['funnelkit-layout-vertical-position']=='top'){
			$funnelkit_content_styles .= 'margin-top:'.$funnelkit_info[0]['funnelkit-layout-vertical-position-top'].'px;';
		}
		
		
		if($funnelkit_info[0]['funnelkit-layout-outer-glow-enable']=='on'){
			$funnelkit_content_styles .= 'box-shadow: 0 0 '.$funnelkit_info[0]['funnelkit-layout-outer-glow-size'].'px #'.$funnelkit_info[0]['funnelkit-layout-outer-glow-color'].';';
		}
		
		//exit message
		if($funnelkit_info[0]['funnelkit-exit-message-enabled']=='on'){
			$funnelkit_exit_rgb = $this->hex2rgb($funnelkit_info[0]['funnelkit-exit-message-background-color']);
			$funnelkit_exit_opacity = '0.8';
			$funnelkit_exit_styles .= '#exitpopup{width:'.$funnelkit_info[0]['funnelkit-exit-message-width'].'px; padding:20px; background:rgb('.  implode(',', $funnelkit_exit_rgb).'); background:rgba('.  implode(',', $funnelkit_exit_rgb).', '.$funnelkit_exit_opacity.');filter: progid:DXImageTransform.Microsoft.gradient(GradientType=0,startColorstr=\'#'.$funnelkit_info[0]['funnelkit-exit-message-background-color'].'\', endColorstr=\'#'.$funnelkit_info[0]['funnelkit-exit-message-background-color'].'\');}';
			
			
			$funnelkit_content_styles .= 'filter: progid:DXImageTransform.Microsoft.gradient(GradientType=0,startColorstr=\'#'.$funnelkit_info[0]['funnelkit-layout-color'].'\', endColorstr=\'#'.$funnelkit_info[0]['funnelkit-layout-color'].'\');';
			$funnelkit_exit_content .= nl2br($this->replace_placeholders($funnelkit_info[0]['funnelkit-exit-message-exit-message'],$user_info));
			if($funnelkit_info[0]['funnelkit-exit-message-can-closed']=='on'){
				$funnelkit_scripts .= 'var enable_close_exit_message="1";';
			}else{
				$funnelkit_scripts .= 'var enable_close_exit_message="0";';
			}
			$funnelkit_scripts .= 'init_exit_message();';
		//	$funnelkit_scripts .= ' var exit_url = "'.$funnelkit_info[0]['funnelkit-exit-message-exit-url'].'"; var exit_message = "'.$funnelkit_info[0]['funnelkit-exit-message-exit-message'].'";init_exit_message();';
		}
		if(!empty($funnelkit_info[0]['funnelkit-page-title'])) {
			$funnelkit_scripts .= 'document.title = "'.$funnelkit_info[0]['funnelkit-page-title'].'";';
		}
		// $funnelkit_tracking_code
		$funnelkit_tracking_code = $funnelkit_info[0]['funnelkit-tracking-html-code'];
		
		$funnelkit_content = $this->funnelkit_render_html($funnelkit_info[0],$user_info);
		include_once FUNNELKIT_GUI_ABSPATH.'/tpl/funnelkit_view.tpl.php';
	}
	
	function hex2rgb($hex) {
		$hex = str_replace("#", "", $hex);

		if(strlen($hex) == 3) {
		   $r = hexdec(substr($hex,0,1).substr($hex,0,1));
		   $g = hexdec(substr($hex,1,1).substr($hex,1,1));
		   $b = hexdec(substr($hex,2,1).substr($hex,2,1));
		} else {
		   $r = hexdec(substr($hex,0,2));
		   $g = hexdec(substr($hex,2,2));
		   $b = hexdec(substr($hex,4,2));
		}
		$rgb = array($r, $g, $b);
		return $rgb;
	}
	
	
    function add_funnelkit_admin_menu() {
		$route = array_fill_keys(array('list', 'edit', 'settings', 'license'),'funnelkit_license');
		if(isset($this->settings['mode'])){
			$route = array_fill_keys(array('list', 'edit', 'setting', 'license'),'funnelkit_license');
			$route = array_merge($route, array_fill_keys(array('edit', 'setting'),'funnelkit_edit'));
			$route = array_merge($route, array_fill_keys(array('settings'),'funnelkit_settings'));
			$route = array_merge($route, array_fill_keys(array('list'),'funnelkit_list'));
		}
		add_menu_page('funnelkit', 'FunnelKit', 'administrator', 'funnelkit', array($this, $route['list']));
		add_submenu_page('funnelkit', 'View Pages', 'View Pages', 'manage_options', 'funnelkit', array($this, $route['list']));
		add_submenu_page('funnelkit', 'Add new', 'Add new', 'manage_options', 'funnelkit_edit', array($this, $route['edit']));
		//add_submenu_page('funnelkit', 'Settings', 'Settings', 'manage_options', 'funnelkit_settings', array($this, $route['settings']));
		add_submenu_page('funnelkit', 'License', 'License', 'manage_options', 'funnelkit_license', array($this, $route['license']));
    }
	 
	function preload_funnelkit_scripts(){
		wp_register_script( 'wp-funnelkit-events-js', ( FUNNELKIT_GUI_RELPATH . "/js/editor.js" ), null, null, true );
		wp_enqueue_script( 'wp-funnelkit-events-js' );
		
		wp_register_script( 'wp-funnelkit-ddeditor-js', ( FUNNELKIT_RES_RELPATH . "/dd-editor/dd-editor.js" ), null, null, true );
		wp_enqueue_script( 'wp-funnelkit-ddeditor-js' );

		
		wp_register_script( 'wp-jscolor-jscolor-js', ( FUNNELKIT_RES_RELPATH . "/jscolor/jscolor.js" ), null, null, true );
		wp_enqueue_script( 'wp-jscolor-jscolor-js' );

		wp_register_script( 'wp-ion-rangeSlider-js', ( FUNNELKIT_RES_RELPATH . "/ion.rangeSlider/js/ion-rangeSlider/ion.rangeSlider.min.js" ), null, null, true );
		wp_enqueue_script( 'wp-ion-rangeSlider-js' );
		
		wp_register_script( 'wp-base64-js', ( FUNNELKIT_RES_RELPATH . "/base64/encoder.js" ), null, null, true );
		wp_enqueue_script( 'wp-base64-js' );
		

		

		
		wp_enqueue_media();
		wp_enqueue_script( 'jquery-ui-sortable' );
		wp_enqueue_script( 'jquery-ui-tabs' );
		
		
	}
	function preload_funnelkit_styles(){
		wp_register_style( 'wp-funnelkit-editor-css', FUNNELKIT_GUI_RELPATH . '/css/editor.css');
		wp_enqueue_style(  'wp-funnelkit-editor-css');
		
		wp_register_style( 'wp-funnelkit-ddeditor-css', FUNNELKIT_RES_RELPATH . '/dd-editor/dd-editor.css');
		wp_enqueue_style(  'wp-funnelkit-ddeditor-css');
		
		wp_register_style( 'wp-rangeSlider-normalize-css', FUNNELKIT_RES_RELPATH . '/ion.rangeSlider/css/normalize.min.css');
		wp_enqueue_style(  'wp-rangeSlider-normalize-css');
		
		wp_register_style( 'wp-rangeSlider-rangeSlider-css', FUNNELKIT_RES_RELPATH . '/ion.rangeSlider/css/ion.rangeSlider.css');
		wp_enqueue_style(  'wp-rangeSlider-rangeSlider-css');
		
		wp_register_style( 'wp-rangeSlider-skinSimple-css', FUNNELKIT_RES_RELPATH . '/ion.rangeSlider/css/ion.rangeSlider.skinNice.css');
		wp_enqueue_style(  'wp-rangeSlider-skinSimple-css');
		
		wp_enqueue_style('thickbox');
	}
	
	function preload_funnelkit_settings_styles(){
		wp_register_style( 'wp-funnelkit-settings-css', FUNNELKIT_GUI_RELPATH . '/css/settings.css');
		wp_enqueue_style(  'wp-funnelkit-settings-css');
	}
	
	function preload_funnelkit_list_styles(){
		wp_register_style( 'wp-funnelkit-list-css', FUNNELKIT_GUI_RELPATH . '/css/list.css');
		wp_enqueue_style(  'wp-funnelkit-list-css');
	}
	

	function funnelkit_list(){
		$args = array(
			'numberposts' => -1, 'offset' => 0,
			'category' => 0, 'orderby' => 'post_date',
			'order' => 'DESC', 'post_type' => 'funnelkit',
			'suppress_filters' => true, 'posts_per_page' => -1
		);

		
		
		$funnelkit_posts = new WP_Query;
		$funnelkit_list =  $funnelkit_posts->query($args);
		$this->load_template('funnelkit_list', $funnelkit_list);
	}
	
	
	function load_template($template_name){
		include_once FUNNELKIT_GUI_ABSPATH.'/tpl/'.$template_name.'.tpl.php';
		show_template(func_get_args());
	}
				
	function funnelkit_post_events(){
		if(isset($_GET['action']) and $_GET['action']=='trash'){
			$post_id = $_GET['post'];
			wp_delete_post($post_id,  TRUE);
			delete_post_meta($post_id, 'funnelkit-data');
			$record_url = add_query_arg(array('page'=>'funnelkit'), admin_url('admin.php'));
			header("Location: $record_url", true, 302);
			die();
		} elseif(isset($_GET['action']) and $_GET['action']=='copy'){
			$post_id = $_GET['post'];
			$funnelkit_info = get_post_meta($post_id, 'funnelkit-data');
			
			$post_info = array(
				'post_status' => 'publish', 
				'post_type' => 'funnelkit',
				//'post_content' => $this->funnelkit_render_html($full_info),
				'post_title' => urldecode($_GET['name']). " (Copy)"
			);
			
			$new_postid = wp_insert_post($post_info);
			wp_update_post($post_info);
			update_post_meta($new_postid, 'funnelkit-data', $funnelkit_info[0]);
			
			$record_url = add_query_arg(array('page'=>'funnelkit'), admin_url('admin.php'));
			header("Location: $record_url", true, 302);
			die();
		} elseif($_GET['action'] == "export") {
			$post_id = $_GET['post'];
			$funnelkit_info = get_post_meta($post_id, 'funnelkit-data');
			$funnelkit_info = $funnelkit_info[0];
			if(!empty($funnelkit_info['funnelkit-background-image-url'])) {
				$data = $this->funnelkit_get($funnelkit_info['funnelkit-background-image-url']);
				$base64 = base64_encode($data);
				$ext = end(explode('.',$funnelkit_info['funnelkit-background-image-url']));
				$funnelkit_info['images']['bg'] = array('ext' => $ext, 'data' => $base64);
			}
			
			$j = json_decode($funnelkit_info['funnelkit-editor-content']);
			if(is_object($j)) {
				if(is_array($j->childs)) {
					foreach($j->childs as $k1 => $gr) {
						foreach($gr as $k2 => $ch) {
							if(!empty($ch->coll_image_url)) {
								$data = $this->funnelkit_get($ch->coll_image_url);
								$base64 = base64_encode($data);
								$ext = end(explode('.',$ch->coll_image_url));
								$funnelkit_info['images']['childs'][$k1][$k2] = array('ext' => $ext, 'data' => $base64);
								unset($data);
								unset($base64);
								unset($ext);
							}
						}
					}
				}
			}
			header ('Content-Type: application/octet-stream');
			header('Content-Disposition: attachment; filename="'.urldecode($_GET['name']).'.txt"');
		    header('Expires: 0');
		    header('Cache-Control: must-revalidate');
		    header('Pragma: public');
			echo serialize($funnelkit_info);
			exit;
		} elseif($_GET['action'] == "export_html") {
			$post_id = $_GET['post'];
			$post = get_post($post_id);
			$page_contents = $this->funnelkit_get(site_url()."/funnelkit/".$post->post_name."?force_save=true&folder=".$post->post_name);
			if(!is_dir(FUNNELKIT_ABSPATH."/export/{$post->post_name}/")) {
				mkdir(FUNNELKIT_ABSPATH."/export/{$post->post_name}/");
			}
			$fh = fopen(FUNNELKIT_ABSPATH."/export/{$post->post_name}/index.html","w");
			fwrite($fh,$page_contents);
			fclose($fh);
			$zipping = $this->zip(FUNNELKIT_ABSPATH."/export/{$post->post_name}/", FUNNELKIT_ABSPATH."/export/{$post->post_name}.zip");
			if(!ini_get('allow_url_fopen')) {
				exit("Your server does not support 'file_get_contents' function, you can either request your server admins to enable this function or download the exported files manually by navigating to the following folder on your server and downloading the uncompressed version: ".FUNNELKIT_RELPATH."/export/{$post->post_name}/");
			} elseif(!$zipping) {
				exit("Your server does not support compressing function, please navigate to the following folder on your server and download uncompressed version: ".FUNNELKIT_RELPATH."/export/{$post->post_name}/");
			} else {
			    header("Content-Type: application/zip");
			    header("Content-Disposition: attachment; filename={$post->post_name}.zip");
			    header("Content-Length: " . filesize(FUNNELKIT_ABSPATH."/export/{$post->post_name}.zip"));
			
			    readfile(FUNNELKIT_ABSPATH."/export/{$post->post_name}.zip");
			    unlink(FUNNELKIT_ABSPATH."/export/{$post->post_name}.zip");
			    $this->funnelkit_remove_export_dir(FUNNELKIT_ABSPATH."/export/{$post->post_name}/");
			    exit;
			}
			exit;
			
			
		}
		if(isset($_POST['funnelkit-post-id'])){
			$full_info = array();
			foreach ($_POST as $post_key=>$post_value){
				if(strpos($post_key, 'funnelkit')===0){
					$full_info[$post_key] = $post_value;
				}
			}
			if(sizeof($full_info)>0){
				//scoding
				if($full_info['funnelkit-subscribion-custom-styles'] == "on") {
					//parse the form
					if(!empty($full_info['funnelkit-subscribion-html-code'])) {
						require_once('simple_html_dom.php');
						$html = str_get_html(stripslashes($full_info['funnelkit-subscribion-html-code']));
						$form = $html->find("form",0);
						
						$action = $form->action;
						
						$inputs = array();
						$hidden = array();
						
						$input_style = 
						'color:#'.$full_info['funnelkit-subscribion-inputs-font-color'].'!important;
						font-size:'.$full_info['funnelkit-subscribion-inputs-font-size'].'px!important; 
						font-family:'.str_replace('"','',$full_info['funnelkit-subscribion-inputs-font-style']).' !important;
						width:'.$full_info['funnelkit-subscribion-fields-width'].'px!important; 
						height:'.$full_info['funnelkit-subscribion-fields-height'].'px!important; 
						padding:'.$full_info['funnelkit-subscribion-fields-padding'].'px!important;
						background:#'.$full_info['funnelkit-subscribion-fields-color'].'!important;
						border:'.$full_info['funnelkit-subscribion-fields-border'].'px #'.$full_info['funnelkit-subscribion-fields-border-color'].' '.$full_info['funnelkit-subscribion-fields-style'].';!important;
						float:'.($full_info['funnelkit-subscribion-input-field-align'] != "center" ? $full_info['funnelkit-subscribion-input-field-align'] : "none").';';
						
						if($full_info['funnelkit-subscribion-fields-border-round'] == "on") {
							$input_style .= '-moz-border-radius:'.$full_info['funnelkit-subscribion-fields-round-radius'].'px;border-radius: '.$full_info['funnelkit-subscribion-fields-round-radius'].'px;';
						}
						$input_style .= 'font-style:'.$full_info['funnelkit-subscribion-inputs-font-styling'].';';
						$input_style .= 'font-weight:'.$full_info['funnelkit-subscribion-inputs-font-weight'].';';
						$input_style .= 'text-decoration:'.$full_info['funnelkit-subscribion-inputs-text-decoration'].';';
						$input_style .= 'text-align:'.$full_info['funnelkit-subscribion-inputs-text-align'].';';
						
						$visible_inputs = $form->find('input');
						if(is_array($visible_inputs)) {
							foreach($visible_inputs as $i) {
								if($i->type != "hidden" AND $i->type != "submit" AND $i->type != "image" AND strpos($i->parent()->style,"absolute") === FALSE) {
									
									if(strpos($i->class,"wf-input") !== FALSE) {
										
										//GR override
										if(strpos($i->parent()->parent()->parent()->style, "none") !== FALSE OR strpos($i->parent()->parent()->style, "none") !== FALSE) {
											continue;
										}
									}
									$js_insert = 'onfocus="if(this.value ==\''.$i->value.'\' ) this.value=\'\'" onblur="if(this.value==\'\') this.value=\''.$i->value.'\'"';
									$inputs[] = ($full_info['funnelkit-subscribion-input-field-align'] == "center" ? "<center>" : "") .'<input name="'.$i->name.'" value="'.$i->value.'" id="'.$i->id.'" '.$js_insert.' style="'.$input_style.'" />'.($full_info['funnelkit-subscribion-input-field-align'] == "center" ? "</center>" : "")."\n\n";
								} elseif($i->type == "hidden" OR strpos($i->parent()->style,"absolute") !== FALSE) {
									$hidden[] = '<input type="hidden" name="'.$i->name.'" value="'.$i->value.'" />';
								}
							}
						}
						$js = $html->find("script");
						if(is_array($js)) {
							foreach($js as $j) {
								$jss[] = $j;
							}
						}
						//pre($inputs);
						//pre($hidden);
						//exit;
						$form_code = "<div style='".($full_info['funnelkit-form-no-bg'] != "on" ? "
						background:#{$full_info['funnelkit-subscribion-body-color']}!important;" : "background:none!important;"
						)."
						width:{$full_info['funnelkit-subscribion-body-width']}px!important;
						padding:{$full_info['funnelkit-subscribion-body-padding']}px!important;
						opacity:".($full_info['funnelkit-subscribion-body-opacity'] / 100)."!important;
						border:#{$full_info['funnelkit-subscribion-border-color']} {$full_info['funnelkit-subscribion-border-size']}px {$full_info['funnelkit-subscribion-border-style']}!important;
						'>";
						$form_code .= "<form action='{$action}' method='POST'>"."\n\n"; 
						$form_code .= "<table style='margin:0 !important; border:0!important;width:100%;' border='0'>"."\n\n";	
						foreach($inputs as $input) {
							$form_code .= "<tr><td style='border:0 !important;'>{$input}</td></tr>"."\n\n";
						}
						foreach($hidden as $h) {
							$form_code .= $h."\n\n";
						}
						$form_code .= "<tr><td style='border:0 !important;'>".($full_info['funnelkit-subscribion-submit-button-aligh'] == "center" ? "<center>" : "") ."<input type='image' src='{$full_info['funnelkit-subscribion-submit-button']}' style='float:".($full_info['funnelkit-subscribion-submit-button-aligh'] != "center" ? $full_info['funnelkit-subscribion-submit-button-aligh'] : "none") ."!important; background:none!important;border:0!important;margin-top:{$full_info['funnelkit-subscribion-submit-button-margin-top']}px;margin-bottom:{$full_info['funnelkit-subscribion-submit-button-margin-bottom']}px;' width='{$full_info['funnelkit-subscribion-submit-button-width']}' value='submit'/>".($full_info['funnelkit-subscribion-submit-button-aligh'] == "center" ? "</center>" : "") ."</td></tr>"."\n\n";
						$form_code .= "</table></form></div>"."\n\n";
						if(is_array($jss)) {
							foreach($jss as $js) {
								$form_code .= $js. "\n\n";
							}
						}
						$full_info['funnelkit-subscribion-html-code'] = $form_code;
					}
				}
				//end
				$post_info = array(
					'post_status' => 'publish', 
					'post_type' => 'funnelkit',
					//'post_content' => $this->funnelkit_render_html($full_info),
					'post_title' => $full_info['funnelkit-page-name']
				);
				if(isset($_POST['funnelkit-post-id']) and $_POST['funnelkit-post-id']>0){
					$post_info['ID'] = $_POST['funnelkit-post-id'];
				}
				
				$new_postid = wp_insert_post($post_info);
				wp_update_post($post_info);
				update_post_meta($new_postid, 'funnelkit-data', $full_info);
			}
			if($_POST['funnelkit-post-id']>0){
				$record_url = add_query_arg(array('page'=>'funnelkit','notify'=>'created', 'updated_id' => $_POST['funnelkit-post-id']), admin_url('admin.php'));
			}else{
				$record_url = add_query_arg(array('page'=>'funnelkit','notify'=>'created', 'new_id'=>$new_postid), admin_url('admin.php'));
			}
			
			if($_GET['action'] != 'funnelkit_quicksave') {
				try {
					header("Location: $record_url", true, 302);
				} catch(Exception $e) {
					echo "hmm";
					pre($e);
				}
			} else {
				exit("OK");
			}
			die();
		}
	}
	function funnelkit_remove_export_dir($path) {
		$dh  = opendir($path);
		while (false !== ($filename = readdir($dh))) {
		    if($filename == "." OR $filename == "..") continue;
		    if(is_dir($filename)) {
		    	$this->funnelkit_remove_export_dir($path.$filename."/");
		    } else {
		    	unlink($path.$filename);
		    }
		}
		if(is_dir($path)) rmdir($path);
	}
	function zip($source, $destination) {
	    if (!extension_loaded('zip') || !file_exists($source)) {
	        return false;
	    }
	
	    $zip = new ZipArchive();
	    if (!$zip->open($destination, ZIPARCHIVE::CREATE)) {
	        return false;
	    }
	
	    $source = str_replace('\\', '/', realpath($source));
	
	    if (is_dir($source) === true)
	    {
	        $files = new RecursiveIteratorIterator(new RecursiveDirectoryIterator($source), RecursiveIteratorIterator::SELF_FIRST);
	
	        foreach ($files as $file)
	        {
	            $file = str_replace('\\', '/', $file);
	
	            // Ignore "." and ".." folders
	            if( in_array(substr($file, strrpos($file, '/')+1), array('.', '..')) )
	                continue;
	
	            $file = realpath($file);
	
	            if (is_dir($file) === true)
	            {
	                $zip->addEmptyDir(str_replace($source . '/', '', $file . '/'));
	            }
	            else if (is_file($file) === true)
	            {
	                $zip->addFromString(str_replace($source . '/', '', $file), file_get_contents($file));
	            }
	        }
	    }
	    else if (is_file($source) === true)
	    {
	        $zip->addFromString(basename($source), file_get_contents($source));
	    }
	
	    return $zip->close();
	}
	function funnelkit_edit(){
		if($_GET['action'] == "import" ) {
			if(isset($_FILES['funnelkit-uploadedfile'])) {
				if(empty($_FILES['funnelkit-uploadedfile']['tmp_name'])) {
					$errors[] = "Please specify a file";
				} else {
					$file = fopen($_FILES['funnelkit-uploadedfile']['tmp_name'],"r");
					$data = fread($file,filesize($_FILES['funnelkit-uploadedfile']['tmp_name']));
					fclose($file);
					$data = unserialize($data);
					if(!is_array($data)) {
						$errors[] = "Invalid file";
					}
				} 
				if(empty($_POST['funnelkit-new-name'])) $errors[] = "Please enter a name";
				if(!is_array($errors)) {
					$data['funnelkit-page-name'] = $_POST['funnelkit-new-name'];
					//process 
					$upload_dir = wp_upload_dir();
					$public_upload_dir = $upload_dir['url']."/";
					$upload_dir = $upload_dir['path']."/";
					
					if(is_array($data['images'])) {
						if(is_array($data['images']['bg'])) {
							$new_name = md5(microtime()).".".$data['images']['bg']['ext'];
							$fh = fopen($upload_dir.$new_name,"w");
							fwrite($fh, base64_decode($data['images']['bg']['data']));
							fclose($fh);
							$data['funnelkit-background-image-url'] = $public_upload_dir.$new_name;
						}
					}
					$j = json_decode($data['funnelkit-editor-content']);
					if(is_object($j)) {
						if(is_array($j->childs)) {
							foreach($j->childs as $k1 => $gr) {
								foreach($gr as $k2 => $ch) {
									if(!empty($ch->coll_image_url) AND is_array($data['images']['childs'][$k1][$k2])) {
										$new_name = md5(microtime()).".".$data['images']['childs'][$k1][$k2]['ext'];
										$fh = fopen($upload_dir.$new_name,"w");
										fwrite($fh, base64_decode($data['images']['childs'][$k1][$k2]['data']));
										fclose($fh);
										$j->childs[$k1][$k2]->coll_image_url = $public_upload_dir.$new_name;
									}
								}
							}
						}
						$data['funnelkit-editor-content'] = json_encode($j);
					}
					unset($data['images']);
					$post_info = array(
						'post_status' => 'publish', 
						'post_type' => 'funnelkit',
						//'post_content' => $this->funnelkit_render_html($full_info),
						'post_title' => $_POST['funnelkit-new-name']
					);
					
					$new_postid = wp_insert_post($post_info);
					wp_update_post($post_info);
					update_post_meta($new_postid, 'funnelkit-data', $data);
				}
			} 
			include_once FUNNELKIT_GUI_ABSPATH.'/tpl/funnelkit_import.tpl.php';
			return;
		} 
		$fonts_list = $this->available_web_fonts();
		$border_styles = array("dashed","dotted","solid");
		$submit_buttons_styles = $this->funnelkit_get_buttons_styles();
		$post_id = 0;
		if(isset($_GET['post'])){
			$this->current_post = get_post_meta($_GET['post'], 'funnelkit-data');
			$post_id = $_GET['post']+0;
		}
		include_once FUNNELKIT_GUI_ABSPATH.'/tpl/funnelkit_edit.tpl.php';
	}


	
	function set_value($value_name, $default=''){

		if(isset($this->current_post[0][$value_name])){
			return $this->current_post[0][$value_name];
		}else{
			return $default;
		}
	}
	
	function funnelkit_render_html($full_info,$user_info = false){
		$main_content_info = json_decode($full_info['funnelkit-editor-content']);
		$this->current_page = '';
		$this->funnelkit_render_container($main_content_info->childs[0], $user_info);
		return $this->current_page;
	}
	
	function funnelkit_render_container($content_section,$user_info = false){
		if(sizeof($content_section)==0){return;}
		foreach ($content_section as $content_item){
		//	var_dump($content_item);
			$container_styles = '';
			if(isset($content_item->coll_width_type)){
				if($content_item->coll_width_type=='full'){
					
				}else{
					if($content_item->coll_fixed_width_type=='fixed-pixels'){
						$container_styles .='width:'.$content_item->coll_fixed_width_pixels.'px;';
					}else{
						if($content_item->coll_fixed_width_percent!=100){
							$container_styles .='width:'.$content_item->coll_fixed_width_percent.'%;';
						}
					}
				}
			}
			if(isset($content_item->coll_background_color)){
				if($content_item->coll_no_background_color=='false'){
					$container_styles .='background-color:#'.$content_item->coll_background_color.';';
				}
			}
			if(isset($content_item->coll_border_size)){
				$container_styles .='border-width:'.$content_item->coll_border_size.'px;';
				$container_styles .='border-color:#'.$content_item->coll_border_color.';';
				$container_styles .='border-style:solid;';
				
			}
			if(isset($content_item->coll_round_conners) and $content_item->coll_round_conners=='true'){
				$container_styles .='border-radius:20px;';
			}
			
			$padding_styles = '';
			if (isset($content_item->coll_height)){
				$padding_styles .= 'height: '.$content_item->coll_height.'px;';
			}
			if (isset($content_item->coll_padding)){
				$padding_styles .= 'padding: '.$content_item->coll_padding.'px;';
			}
			
			if(!empty($content_item->coll_height)) {
				$this->current_page .= "\n<div style='height:".$content_item->coll_height."px; overflow:hidden;'>";
			}
			if(!empty($content_item->coll_align)) {
				if($content_item->coll_align == "center") {
					$this->current_page .=  "\n  <center>";
				} else {
					$this->current_page .= "\n  <div style=\"float:{$content_item->coll_align};width:100%;\">";
				}
			}
			//coll_background_color
			$this->current_page .= "\n<div style='".$container_styles."' class=\"section section-".$content_item->type."\">";
			$this->current_page .= "\n<div style='".$padding_styles."'>";
			
			if ($content_item->is_container){
				if($content_item->type=='1-coll-element'){
					$this->current_page .= "\n  <div class=\"subsections section-".$content_item->type."-0\">";
					$this->current_page .= ''.$this->funnelkit_render_container($content_item->childs[0],$user_info);
					$this->current_page .= "\n  <div style='clear:both;'></div></div>";
				}
				if($content_item->type=='2-coll-element'){
					$total_width = $content_item->coll_ratio_left+$content_item->coll_ratio_right;
					if(!isset($content_item->coll_width_type) OR $content_item->coll_width_type != "fixed") {
						$content_item->coll_ratio_left= $content_item->coll_ratio_left;
						$content_item->coll_ratio_right=$content_item->coll_ratio_right;
					} else {
						if($total_width<=0){
							$content_item->coll_ratio_left=50;
							$content_item->coll_ratio_right=50;
						}
						if($total_width!=100){
							$koef = 100/$total_width;
							$content_item->coll_ratio_left=round($content_item->coll_ratio_left*$koef);
							$content_item->coll_ratio_right=round($content_item->coll_ratio_right*$koef);
						}
					}
					
					$this->current_page .= "\n  <div style='width:".$content_item->coll_ratio_left."%' class=\"subsections section-".$content_item->type."-0\">";
					$this->current_page .= "\n  <div style='padding-right:".($content_item->coll_ratio_padding_1/2)."px'>";
					$this->current_page .= ''.$this->funnelkit_render_container($content_item->childs[0],$user_info);
					$this->current_page .= "\n  </div>";
					$this->current_page .= "\n  </div>";

					$this->current_page .= "\n  <div style='width:".$content_item->coll_ratio_right."%' class=\"subsections section-".$content_item->type."-1\">";
					$this->current_page .= "\n  <div style='padding-left:".($content_item->coll_ratio_padding_1/2)."px'>";
					$this->current_page .= ''.$this->funnelkit_render_container($content_item->childs[1],$user_info);
					$this->current_page .= "\n  </div>";
					$this->current_page .= "\n  </div><div style='clear:both;'></div>";
				}
				
				if($content_item->type=='3-coll-element'){
					
					$total_width = $content_item->coll_ratio_left+$content_item->coll_ratio_right+$content_item->coll_ratio_middle;
					if(!isset($content_item->coll_width_type) OR $content_item->coll_width_type != "fixed") {
						$content_item->coll_ratio_left= $content_item->coll_ratio_left;
						$content_item->coll_ratio_right=$content_item->coll_ratio_right;
						$content_item->coll_ratio_middle=$content_item->coll_ratio_middle;
					} else {
						if($total_width<=0){
							$content_item->coll_ratio_left=33;
							$content_item->coll_ratio_right=33;
							$content_item->coll_ratio_middle=33;
						}
						if($total_width!=100){
							$koef = 100/$total_width;
							$content_item->coll_ratio_left=round($content_item->coll_ratio_left*$koef);
							$content_item->coll_ratio_right=round($content_item->coll_ratio_right*$koef);
							$content_item->coll_ratio_middle=round($content_item->coll_ratio_middle*$koef);
						}
					}
					$this->current_page .= "\n  <div style='width:".$content_item->coll_ratio_left."%' class=\"subsections section-".$content_item->type."-0\">";
					$this->current_page .= "\n  <div style='padding-right:".($content_item->coll_ratio_padding_1/2)."px;'>";
					$this->current_page .= ''.$this->funnelkit_render_container($content_item->childs[0],$user_info);
					$this->current_page .= "\n  </div>";
					$this->current_page .= "\n  </div>";

					$this->current_page .= "\n  <div style='width:".$content_item->coll_ratio_middle."%' class=\"subsections section-".$content_item->type."-1\">";
					$this->current_page .= "\n  <div style='padding-left:".($content_item->coll_ratio_padding_1/2)."px;padding-right:".($content_item->coll_ratio_padding_2/2)."px;'>";
					$this->current_page .= ''.$this->funnelkit_render_container($content_item->childs[1],$user_info);
					$this->current_page .= "\n  </div>";
					$this->current_page .= "\n  </div>";
					
					$this->current_page .= "\n  <div style='width:".$content_item->coll_ratio_right."%' class=\"subsections section-".$content_item->type."-2\">";
					$this->current_page .= "\n  <div style='padding-left:".($content_item->coll_ratio_padding_2/2)."px;'>";
					$this->current_page .= ''.$this->funnelkit_render_container($content_item->childs[2],$user_info);
					$this->current_page .= "\n  </div>";
					$this->current_page .= "\n  </div>";
				}

				$this->current_page .= "<div style='clear:both'></div>";
			}else{
				$this->current_page .= $this->render_content_block($content_item,$user_info);
			}
			
			$this->current_page .= "<div style='clear:both'></div>";
			$this->current_page .= "\n</div>";
			$this->current_page .= "<div style='clear:both'></div>";
			$this->current_page .= "\n</div>";
			if(!empty($content_item->coll_align)) {
				if($content_item->coll_align == "center") {
					$this->current_page .=  "\n  </center>";
				} else {
					$this->current_page .= "<div style='clear:both'></div>";
					$this->current_page .= "\n  </div>";
				}
			}
			if(!empty($content_item->coll_height)) {
				$this->current_page .= "<div style='clear:both'></div>";
				$this->current_page .= "\n</div>";
			}
			if($content_item->type=='1-coll-element'){
				$this->current_page .= "<div style='clear:both'></div>";
			}
			
		}
	}
	function get_youtube_id($url) {
		if(strpos($url, "youtu.be") !== FALSE) {
			$e = explode('/',$url);
			return end($e);
		}
		$query = parse_url($url, PHP_URL_QUERY);
		parse_str($query, $params);
		
		if(!empty($params['z'])) {
			$ytID= $params['z'];
		} else {
			$ytID = $params['v'];
		}
		return $ytID;
	}
	function export_image($img_url) {
		$end = end(explode(".",$img_url));
		$contents = $this->funnelkit_get($img_url);
		$new_name = md5(microtime()).".".$end;
		if(!is_dir(FUNNELKIT_ABSPATH."/export/{$_GET['folder']}/")) {
			mkdir(FUNNELKIT_ABSPATH."/export/{$_GET['folder']}/");
		}
		if(!is_dir(FUNNELKIT_ABSPATH."/export/{$_GET['folder']}/images/")) {
			mkdir(FUNNELKIT_ABSPATH."/export/{$_GET['folder']}/images/");
		}
		$fh = fopen(FUNNELKIT_ABSPATH."/export/{$_GET['folder']}/images/{$new_name}","w");
		fwrite($fh,$contents);
		fclose($fh);
		return "images/{$new_name}";
	}
	function render_content_block($content_item, $user_info = false){
		
		$content = '';
		$block_styles = '';
		if($content_item->type=='video-element'){
			if ($content_item->coll_video_type=='youtube'){
				$attr = array();
				$attr[] = 'width="'.$content_item->coll_video_youtube_width.'"';
				$attr[] = 'height="'.($content_item->coll_video_youtube_width * 9 /16).'"';
				
				$ytID = $this->get_youtube_id($content_item->coll_video_youtube_id);
				
				$url = '//www.youtube.com/embed/'.$ytID.'?rel=0';
				if($content_item->coll_video_youtube_autostart=='true'){$url.='&autoplay=1';}
				$block_styles = 'style="text-align:'.$content_item->coll_video_youtube_align.';"';
				$content .=  "\n  <div ".$block_styles." class=\"content content-".$content_item->type."\">";
				$content .= '<iframe '.  implode(' ', $attr).' src="'.$url.'" frameborder="0" allowfullscreen></iframe>';
				$content .= "\n  </div>";
			}elseif($content_item->coll_video_type=='embed'){
				$block_styles = 'style="text-align:'.$content_item->coll_video_embed_align.';"';
				$content .=  "\n  <div ".$block_styles." class=\"content content-".$content_item->type."\">";
				$content .= base64_decode($content_item->coll_video_embed_code);
				$content .= "\n  </div>";
			}
		}
		
		if($content_item->type=='image-element'){
			$styles = array();
			if($content_item->coll_image_width>0){$styles[] = 'width:'.$content_item->coll_image_width.'px;';}
			if($content_item->coll_image_height>0){$styles[] = 'height:'.$content_item->coll_image_height.'px;';}
			$block_styles = 'style="text-align:'.$content_item->coll_image_align.';"';
			$content .=  "\n  <div ".$block_styles." class=\"content content-".$content_item->type."\">";
			if(!empty($content_item->coll_image_hotlink_url)) $content .= '<a href="'.$content_item->coll_image_hotlink_url.'" target="'.$content_item->coll_image_url_hotlink_target.'">';
			if(isset($_GET['folder'])) {
				$new_img = $this->export_image($content_item->coll_image_url);
				$content .= '<img alt="" title="" style="'.  implode(' ', $styles).'" src="'.$new_img.'" />';
			} else {
				$content .= '<img alt="" title="" style="'.  implode(' ', $styles).'" src="'.$content_item->coll_image_url.'" />';
			}
			if(!empty($content_item->coll_image_hotlink_url)) $content .= '</a>';
			$content .= '<div style="clear:both"></div>';
			$content .= "\n  </div>";
		}
		
		if($content_item->type=='text-element'){
			$content .=  "\n  <div class=\"content content-".$content_item->type."\">";
			$content .= $this->replace_placeholders(base64_decode($content_item->text_element),$user_info);
			$content .= "\n  </div>";
		}
		
		if($content_item->type=='text-image-left-element'){
			$content .=  "\n  <div class=\"content content-".$content_item->type."\">";
			if($content_item->coll_image_url!=''){
				$styles = array();
				if($content_item->coll_image_width>0){$styles[] = 'width:'.$content_item->coll_image_width.'px;';}
				if($content_item->coll_image_height>0){$styles[] = 'height:'.$content_item->coll_image_height.'px;';}
				if($content_item->coll_image_height>0){$styles[] = 'margin:0 '.$content_item->coll_image_padding.'px '.$content_item->coll_image_padding.'px 0';}
				if(!empty($content_item->coll_image_hotlink_url)) $content .= '<a href="'.$content_item->coll_image_hotlink_url.'" target="'.$content_item->coll_image_url_hotlink_target.'">';
				
				if(isset($_GET['folder'])) {
					$new_img = $this->export_image($content_item->coll_image_url);
					$content .= '<img alt="" title="" style="float:left; '.  implode(' ', $styles).'" src="'.$new_img.'" />';
				} else {
					$content .= '<img alt="" title="" style="float:left; '.  implode(' ', $styles).'" src="'.$content_item->coll_image_url.'" />';
				}

				if(!empty($content_item->coll_image_hotlink_url)) $content .= '</a>';
			}
			$content .= $this->replace_placeholders(base64_decode($content_item->text_image_left_element),$user_info);
			$content .= "<div style='clear:both'></div>";
			$content .= "\n  </div>";
		}
		
		if($content_item->type=='text-image-right-element'){
			$content .=  "\n  <div class=\"content content-".$content_item->type."\">";
			if($content_item->coll_image_url!=''){
				$styles = array();
				if($content_item->coll_image_width>0){$styles[] = 'width:'.$content_item->coll_image_width.'px;';}
				if($content_item->coll_image_height>0){$styles[] = 'height:'.$content_item->coll_image_height.'px;';}
				if($content_item->coll_image_height>0){$styles[] = 'margin:0 0 '.$content_item->coll_image_padding.'px '.$content_item->coll_image_padding.'px';}
				if(!empty($content_item->coll_image_hotlink_url)) $content .= '<a href="'.$content_item->coll_image_hotlink_url.'" target="'.$content_item->coll_image_url_hotlink_target.'">';
				
				if(isset($_GET['folder'])) {
					$new_img = $this->export_image($content_item->coll_image_url);
					$content .= '<img alt="" title="" style="float:right; '.  implode(' ', $styles).'" src="'.$new_img.'" />';
				} else {
					$content .= '<img alt="" title="" style="float:right; '.  implode(' ', $styles).'" src="'.$content_item->coll_image_url.'" />';
				}
				
				if(!empty($content_item->coll_image_hotlink_url)) $content .= '</a>';
			}
			$content .= $this->replace_placeholders(base64_decode($content_item->text_image_right_element),$user_info);
			$content .= "<div style='clear:both'></div>";
			$content .= "\n  </div>";
		}
		
		if($content_item->type == 'optin-form-element'){
			$content .=  "\n  <div class=\"content content-".$content_item->type."\">";
			if(empty($content_item->coll_form_align)) {
				$content_item->coll_form_align = "center";
			}
			if(!empty($content_item->coll_form_align)) {
				$content .= "<div style='";
				if($content_item->coll_form_align == "center") {
					$content .= "margin-left:auto;margin-right:auto;float:none!important;";
				} else {
					$content .= "float:{$content_item->coll_form_align};";
				}
				$content .= "display:table;'>";
			}
			$content .= $this->replace_placeholders($this->optin_form,$user_info);
			if(!empty($content_item->coll_form_align)) {
				$content .= "<style>form {";
				if($content_item->coll_form_align == "center") {
					$content .= "margin-left:auto !important;margin-right:auto !important;float:none!important;";
				} else {
					$content .= "float:{$content_item->coll_form_align} !important;";
				}
				$content .= "display:block !important;}</style>";
			}
			$content .= "\n  <div class='clear'></div></div>";
		}
		
		if($content_item->type == 'data-reach-element'){
			$content .=  "\n  <div class=\"content content-".$content_item->type."\">";
			if(empty($content_item->coll_form_align)) {
				$content_item->coll_form_align = "center";
			}
			if(!empty($content_item->coll_form_align)) {
				$content .= "<div style='";
				if($content_item->coll_form_align == "center") {
					$content .= "margin-left:auto;margin-right:auto;float:none!important;";
				} else {
					$content .= "float:{$content_item->coll_form_align};";
				}
				$content .= "display:table;'>";
			}
			$content .= $this->replace_placeholders($this->optin_form,$user_info);
			if(!empty($content_item->coll_form_align)) {
				$content .= "<style>form {";
				if($content_item->coll_form_align == "center") {
					$content .= "margin-left:auto !important;margin-right:auto !important;float:none!important;";
				} else {
					$content .= "float:{$content_item->coll_form_align} !important;";
				}
				$content .= "display:block !important;}</style>";
			}
			$content .= "\n  <div class='clear'></div></div>";
		}
		
		
		
		return $content;
	}
	function replace_placeholders($input, $vars) {
		if(!is_object($vars) OR count($vars) < 0) return $input;
		if(!empty($vars->ip)) {
			$find[] = '%ip%';
			$find[] = '%IP%';
			$find[] = '%Ip%';
			
			$replace[] =  $vars->ip;
			$replace[] =  $vars->ip;
			$replace[] =  $vars->ip;
		}
		if(!empty($vars->country_name)) {
			$find[] = '%country%';
			$find[] = '%COUNTRY%';
			$find[] = '%Country%';
			
			$replace[] = strtolower($vars->country_name);
			$replace[] = strtoupper($vars->country_name);
			$replace[] = ucwords(strtolower($vars->country_name));
		}
		if(!empty($vars->region_name)) {
			$find[] = '%state%';
			$find[] = '%STATE%';
			$find[] = '%State%';
			
			$replace[] = strtolower($vars->region_name);
			$replace[] = strtoupper($vars->region_name);
			$replace[] = ucwords(strtolower($vars->region_name));
		}
		if(!empty($vars->city)) {
			$find[] = '%city%';
			$find[] = '%CITY%';
			$find[] = '%City%';
			
			$replace[] = strtolower($vars->city);
			$replace[] = strtoupper($vars->city);
			$replace[] = ucwords(strtolower($vars->city));
		}
		
		//overall
		//DATE
		$find[] = '%date%';
		$find[] = '%DATE%';
		$find[] = '%Date%';
			
		$replace[] = date("m/d/y");
		$replace[] = date("m/d/y");
		$replace[] = date("m/d/y");

		//TIME
		$find[] = '%time%';
		$find[] = '%TIME%';
		$find[] = '%Time%';
			
		$replace[] = date("H:i");
		$replace[] = date("H:i");
		$replace[] = date("H:i");
		
		//BROWSER
		$browser = $this->getBrowser();
		$find[] = '%browser%';
		$find[] = '%BROWSER%';
		$find[] = '%Browser%';
			
		$replace[] = strtolower($browser['name']);
		$replace[] = strtoupper($browser['name']);
		$replace[] = ucwords(strtolower($browser['name']));
		$input = str_replace($find,$replace,$input);
		
		if(strpos($input,"%countdown") !== FALSE) {
			//handle countdown formating
			//figure out if it's only MM:SS or HH:MM:SS
			$timer_strings = $this->fetchAllBetween("%countdown:","%",$input);
			foreach($timer_strings as $timer_string) {
				$seconds = 0;
				$times = explode(":",$timer_string);
				if(count($times) == 2) {
					//MM:SS
					if($times[0]{0} == "0") {
						$seconds += $times[0]{1} * 60;
					} else {
						$seconds += $times[0] * 60;
					}
					
					if($times[1]{0} == "0") {
						$seconds += $times[1]{1};
					} else {
						$seconds += $times[1];
					}
				} elseif(count($times) == 3) {
					//HH:MM:SS
					if($times[0]{0} == "0") {
						$seconds += $times[0]{1} * 60 * 60;
					} else {
						$seconds += $times[0] * 60 * 60;
					}
					
					if($times[1]{0} == "0") {
						$seconds += $times[1]{1} * 60;
					} else {
						$seconds += $times[1] * 60;
					}
					
					if($times[2]{0} == "0") {
						$seconds += $times[2]{1};
					} else {
						$seconds += $times[2];
					}
				} else {
					//SS
					$seconds = $times[0];
				}
				$input = str_replace("%countdown:".$timer_string."%","<span class='timer' data-seconds='{$seconds}'>{$timer_string}</span>",$input);
			}
		}
		return do_shortcode($input);
		
	}
	function fetchAllBetween($needle1,$needle2,$haystack,$include=false){
		
		$matches = array();
		
		$exp = "|{$needle1}(.*){$needle2}|U";
		
		preg_match_all($exp,$haystack,$matches);
		
		$i = ($include == true) ? 0 : 1 ;
		
		return $matches[$i];
		
	}
	function getBrowser() {
	    $u_agent = $_SERVER['HTTP_USER_AGENT'];
	    $bname = 'Unknown';
	    $platform = 'Unknown';
	    $version= "";
	
	    //First get the platform?
	    if (preg_match('/linux/i', $u_agent)) {
	        $platform = 'linux';
	    }
	    elseif (preg_match('/macintosh|mac os x/i', $u_agent)) {
	        $platform = 'mac';
	    }
	    elseif (preg_match('/windows|win32/i', $u_agent)) {
	        $platform = 'windows';
	    }
	   
	    // Next get the name of the useragent yes seperately and for good reason
	    if(preg_match('/MSIE/i',$u_agent) && !preg_match('/Opera/i',$u_agent))
	    {
	        $bname = 'Internet Explorer';
	        $ub = "MSIE";
	    }
	    elseif(preg_match('/Firefox/i',$u_agent))
	    {
	        $bname = 'Mozilla Firefox';
	        $ub = "Firefox";
	    }
	    elseif(preg_match('/Chrome/i',$u_agent))
	    {
	        $bname = 'Google Chrome';
	        $ub = "Chrome";
	    }
	    elseif(preg_match('/Safari/i',$u_agent))
	    {
	        $bname = 'Apple Safari';
	        $ub = "Safari";
	    }
	    elseif(preg_match('/Opera/i',$u_agent))
	    {
	        $bname = 'Opera';
	        $ub = "Opera";
	    }
	    elseif(preg_match('/Netscape/i',$u_agent))
	    {
	        $bname = 'Netscape';
	        $ub = "Netscape";
	    }
	   
	    // finally get the correct version number
	    $known = array('Version', $ub, 'other');
	    $pattern = '#(?<browser>' . join('|', $known) .
	    ')[/ ]+(?<version>[0-9.|a-zA-Z.]*)#';
	    if (!preg_match_all($pattern, $u_agent, $matches)) {
	        // we have no matching number just continue
	    }
	   
	    // see how many we have
	    $i = count($matches['browser']);
	    if ($i != 1) {
	        //we will have two since we are not using 'other' argument yet
	        //see if version is before or after the name
	        if (strripos($u_agent,"Version") < strripos($u_agent,$ub)){
	            $version= $matches['version'][0];
	        }
	        else {
	            $version= $matches['version'][1];
	        }
	    }
	    else {
	        $version= $matches['version'][0];
	    }
	   
	    // check if we have a number
	    if ($version==null || $version=="") {$version="?";}
	   
	    return array(
	        'userAgent' => $u_agent,
	        'name'      => $bname,
	        'version'   => $version,
	        'platform'  => $platform,
	        'pattern'    => $pattern
	    );
	} 
	function render_optin_form($content){
		$optin_form = $content['funnelkit-subscribion-html-code'];

		
		if($content['funnelkit-subscribion-custom-styles']=='on'){
			/*remove old styles*/
			$optin_form = preg_replace("/<style([\s\S]+?)style>/", "", $optin_form);
			
			/*body*/
			$body_styles = '';
			if($content['funnelkit-subscribion-body-color']!=''){
				$body_styles.="background:#".$content['funnelkit-subscribion-body-color'].";\n";
			}
			if($content['funnelkit-subscribion-body-width']>0){
				$body_styles.="width:".$content['funnelkit-subscribion-body-width']."px;\n";
			}
			
			if($content['funnelkit-subscribion-body-padding']>0){
				$body_styles.="padding:".$content['funnelkit-subscribion-body-padding']."px;\n";
			}
			
			if($content['funnelkit-subscribion-body-opacity']>0 and $content['funnelkit-subscribion-body-opacity']<100){
				$layout_opacity = $content['funnelkit-subscribion-body-opacity']/100;
				$layput_rgb = $this->hex2rgb($content['funnelkit-subscribion-body-color']);
				$body_styles.= 'background-color:rgba('.  implode(',', $layput_rgb).', '.$layout_opacity.');';
			}
			
			if($content['funnelkit-subscribion-border-size']!=0){
				$body_styles.= 'border: '.$content['funnelkit-subscribion-border-size'].'px #'.$content['funnelkit-subscribion-border-color'].' '.$content['funnelkit-subscribion-border-style'].';';
			}

			if($content['funnelkit-subscribion-labels-font-color']!=''){
				$body_styles.="color:#".$content['funnelkit-subscribion-labels-font-color'].";\n";
			}
			if($content['funnelkit-subscribion-labels-font-size']>0){
				$body_styles.="font-size:".$content['funnelkit-subscribion-labels-font-size']."px;\n";
			}
			if($content['funnelkit-subscribion-labels-font-style']>0){
				$body_styles.="font-style:".$content['funnelkit-subscribion-labels-font-style'].";\n";
			}
			
			$field_styles = '';
			if($content['funnelkit-subscribion-inputs-font-color']!=''){
				$field_styles.="color:#".$content['funnelkit-subscribion-inputs-font-color'].";\n";
			}
			if($content['funnelkit-subscribion-inputs-font-size']>0){
				$field_styles.="font-size:".$content['funnelkit-subscribion-inputs-font-size']."px;\n";
			}
			if($content['funnelkit-subscribion-inputs-font-style']!=''){
				$field_styles.="font-style:".$content['funnelkit-subscribion-inputs-font-style'].";\n";
			}
			
			if($content['funnelkit-subscribion-fields-width']!=''){
				$field_styles.="width:".$content['funnelkit-subscribion-fields-width']."px;\n";
			}
			if($content['funnelkit-subscribion-fields-height']!=''){
				$field_styles.="height:".$content['funnelkit-subscribion-fields-height']."px;\n";
			}
			if($content['funnelkit-subscribion-fields-padding']!=''){
				$field_styles.="padding:".$content['funnelkit-subscribion-fields-padding']."px;\n";
			}
			if($content['funnelkit-subscribion-fields-color']!=''){
				$field_styles.="background-color:#".$content['funnelkit-subscribion-fields-color'].";\n";
			}

			if($content['funnelkit-subscribion-fields-border']!=0){
				$field_styles.= 'border: '.$content['funnelkit-subscribion-fields-border'].'px #'.$content['funnelkit-subscribion-fields-border-color'].' '.$content['funnelkit-subscribion-fields-border-style'].';';
			}
			/*
			$button_style = '';
			
			if($content['funnelkit-subscribion-submit-button']!=''){
				 $button_style .= 'background-image:url("'.$content['funnelkit-subscribion-submit-button'].'");';
				 $button_style .= 'width: '.$content['funnelkit-subscribion-submit-button-width'].'px;';
				 $button_style .= 'height: '.$content['funnelkit-subscribion-submit-button-height'].'px;';
				 $button_style .= 'text-indent: -1000px;';
			}

			
			
			$optin_form .= '<style>';
			$optin_form .= '.section-optin-form-element{'.$body_styles.'}'."\n";
			$optin_form .= '.section-optin-form-element input{'.$field_styles.'}'."\n";
			$optin_form .= '.section-optin-form-element input[type="submit"] {'.$button_style.'}'."\n";
			$optin_form .= '</style>';
			*/
		} elseif($content['funnelkit-subscribion-data-reach'] == "on") {
			$optin_form = $content['funnelkit-subscribion-html-code'];
		}
		
		$this->optin_form = $optin_form;
	}
	
	function funnelkit_settings(){
		$this->load_template('funnelkit_settings', array());
	}
	
	function check_license(){
		if(isset($_POST['license_key'])){
			$license_key = explode('-', $_POST['license_key']);
			$res = 0;
			foreach ($license_key as $part){
				for($i=0; $i<5;$i++){
					$res = $res+($i+1)*($i+1)*$part[$i];
				}
			}
						
				$res = array('skey'=>$res.md5(implode('', $license_key)),'mode'=>'fi', 'key'=>  implode('-', $license_key));
			
			update_option('funnelkit.class.license', $res);
			$record_url = add_query_arg(array('page'=>'funnelkit_license'), admin_url('admin.php'));
			header("Location: $record_url", true, 302);
			die();
		}
		if(isset($_GET['do']) and $_GET['do']==='remove_key'){
			update_option('funnelkit.class.license', '');
			$record_url = add_query_arg(array('page'=>'funnelkit_license'), admin_url('admin.php'));
			header("Location: $record_url", true, 302);
			die();
		}
		
	}
	
	function funnelkit_license(){
		if(isset($this->settings['mode'])){
			if($this->settings['mode'] == 'un'){$message = 'your personal <b>JV review</b> license';}
			if($this->settings['mode'] == 'fi'){$message = 'your personal FunnelKit license';}
		}
		$this->load_template('funnelkit_license', $this->settings['key'], $message);
	}
	
	function funnelkit_get_buttons_styles(){
		
		$buttons_list = get_option('funnelkit.settings.buttons_list', array());
		
		if($buttons_list == array()){
			$directory = FUNNELKIT_RES_ABSPATH.'/img-collections/images/';
			$collections_images = glob($directory . "*.png"); 	
			$styles_list= array();
			foreach ($collections_images as $single_button){
				$filename = basename($single_button);
				$file_params = explode('-', $filename);
				if(!isset($styles_list[$file_params[0]])){$styles_list[$file_params[0]]=array();}
				if(!isset($styles_list[$file_params[0]][$file_params[1]])){$styles_list[$file_params[0]][$file_params[1]]=array();}
				$styles_list[$file_params[0]][$file_params[1]][]=FUNNELKIT_RES_RELPATH.'/img-collections/images/'.$filename;
			}
			update_option('funnelkit.settings.buttons_list', $styles_list);
			$buttons_list = $styles_list;
		}
		return $buttons_list;
	}
	
	function available_web_fonts(){
		$fonts_default = array(
'Georgia'=>'Georgia, serif',
'Palatino Linotype'=>'"Palatino Linotype", "Book Antiqua", Palatino, serif',
'Times New Roman'=>'"Times New Roman", Times, serif' ,	
'Arial'=>'Arial, Helvetica, sans-serif' 	,
'Arial Black'=>'"Arial Black", Gadget, sans-serif',
'Comic Sans MS'=>'"Comic Sans MS", cursive, sans-serif',
'Impact'=>'Impact, Charcoal, sans-serif',
'Lucida Sans'=>'"Lucida Sans Unicode", "Lucida Grande", sans-serif',
'Tahoma'=>'Tahoma, Geneva, sans-serif',
'Trebuchet MS'=>'"Trebuchet MS", Helvetica, sans-serif',
'Verdana'=>'Verdana, Geneva, sans-serif',
'Courier New'=>'"Courier New", Courier, monospace',
'Lucida Console'=>'"Lucida Console", Monaco, monospace'
		);
		
		$fonts = get_option('funnelkit.settings.fonts_list', $fonts_default);

		return $fonts;
	}
	
	function do_init(){
		$this->settings = @array_merge(get_option('funnelkit.class.license', array()), get_option('funnelkit.class.settings', array()));
		return true;
	}
	
	
	function funnelkit_init() {
		$labels = array(
			'name'                => _x( 'PunnelKit Pages', 'Post Type General Name', 'funnelkit' ),
			'singular_name'       => _x( 'PunnelKit Pages', 'Post Type Singular Name', 'funnelkit' ),
			'menu_name'           => __( 'PunnelKit Pages', 'funnelkit' ),
			'parent_item_colon'   => __( 'Parent PunnelKit Page:', 'funnelkit' ),
			'all_items'           => __( 'All PunnelKit Pages', 'funnelkit' ),
			'view_item'           => __( 'View PunnelKit Page', 'funnelkit' ),
			'add_new_item'        => __( 'Add New PunnelKit Page', 'funnelkit' ),
			'add_new'             => __( 'New PunnelKit Page', 'funnelkit' ),
			'edit_item'           => __( 'Edit PunnelKit Page', 'funnelkit' ),
			'update_item'         => __( 'Update PunnelKit Page', 'funnelkit' ),
			'search_items'        => __( 'Search PunnelKit Pages', 'funnelkit' ),
			'not_found'           => __( 'No PunnelKit Pages found', 'funnelkit' ),
			'not_found_in_trash'  => __( 'No PunnelKit Pages found in Trash', 'funnelkit' ),
		);
		$rewrite = array(
			'slug'                => 'funnelkit',
			'with_front'          => true,
			
		);
		$args = array(
			'label'               => __( 'funnelkit', 'funnelkit' ),
			'description'         => __( 'PunnelKit Pages', 'funnelkit' ),
			'labels'              => $labels,
			'supports'            => array( 'title', ),
			'taxonomies'          => array( 'category', 'post_tag' ),
			'hierarchical'        => true,
			'public'              => true,
			'show_ui'             => false,
			'show_in_menu'        => true,
			'show_in_nav_menus'   => true,
			'show_in_admin_bar'   => false,
			'menu_position'       => 100,
			'menu_icon'           => '',
			'can_export'          => true,
			'has_archive'         => true,
			'exclude_from_search' => false,
			'publicly_queryable'  => true,
			'query_var'           => 'funnelkit',
			'rewrite'             => $rewrite,
			'capability_type'     => 'page',
		);
		register_post_type( 'funnelkit', $args );
		add_filter( 'get_pages', array($this, 'funnelkit_frontpage_dropdown'), 10, 2 );
		add_action( 'pre_get_posts', array($this, 'funnelkit_frontpage_enable' ));
		add_action( 'wp_ajax_funnelkit_quicksave', array($this, 'funnelkit_quicksave_callback') );
		register_activation_hook( __FILE__, array($this,'funnelkit_activate'));
		register_deactivation_hook( __FILE__, array($this,'funnelkit_deactivate'));
		
		add_filter('wp_redirect', array($this,'funnelkit_disable_redirect'));
		//add_rewrite_rule('(.*?)$', 'index.php?funnelkit=$matches[1]', 'bottom');
	}
	
	
	function funnelkit_disable_redirect($location)
	{
	    //var_dump(debug_backtrace());//if you want know who call redirect
	    $disable_redirect = get_query_var('name');
	    if(!empty($disable_redirect)) {
	    	$args=array(
			  'name' => $disable_redirect,
			  'post_type' => 'funnelkit'
			);
			$my_posts = get_posts($args);
			if( $my_posts ) {
				status_header(200);
			 	global $post; 
				$post = get_post($my_posts[0]->ID, OBJECT );
				setup_postdata( $post );
				define("FUNNELKIT_OVERIDE",TRUE);
				$this->funnelkit_frontend_head();
				$this->funnelkit_frontend_loaded();
				exit;
			}
	    }
	    return $location;
	}
	function funnelkit_frontpage_dropdown( $pages, $r ){
		if ( ! isset( $r[ 'name' ] ) ){
			return $pages;
		}
		if ( 'page_on_front' == $r[ 'name' ] ) {
			$args = array('post_type' => 'funnelkit');
			$items = get_posts( $args );
			$pages = array_merge( $pages, $items );
		}
		return $pages;
	}
	
	function funnelkit_frontpage_enable( $query ){
		global $wp;
		if('' == $query->query_vars['post_type'] && 0 != $query->query_vars['page_id']){
			$query->query_vars['post_type'] = array( 'funnelkit', 'page' );
			if (get_post_type($query->query_vars['page_id'])==='funnelkit'){
				$wp->query_vars['post_type']='funnelkit';
			}
		}
	}
	
	

	function funnelkit_quicksave_callback() {
		$this->funnelkit_post_events();
		
		exit;
	}
	
	function funnelkit_activate_au() {
			}
	function funnelkit_activate() {
		// register taxonomies/post types here
		flush_rewrite_rules();
	}
	
	function funnelkit_deactivate() {
		flush_rewrite_rules();
	}
	
	
}
function pre($a) {
	echo "<pre>".print_r($a,1)."</pre>";
}