/*Step by step scenarios*/

/*Visual*/
var animation_mode = 400;


/*Defaults*/
var defalut_backgroung_type = 'color-solid';
var defalut_map_type = 'static';

var defalut_funnelkit_layout_width = 'full-width';
var defalut_funnelkit_layout_horizontal_position = 'middle';
var defalut_funnelkit_layout_vertical_position = 'top';

var defalut_funnelkit_callout_position = 'bottom-right';

/*Global init*/
jQuery(document).ready(function($){	
	show_step_1();
});

/*Steps navigation*/
jQuery(document).ready(function($){

	$('.funnelkit-step-container').on('click', function(){
		var current_section = jQuery(this).attr('id');
		if(current_section === 'step-id-1'){	
			check_toolboxes_overflow_reset();
			show_step_1();
		};
		if(current_section === 'step-id-2'){
			
			show_step_2();
			check_toolboxes_overflow(1250,400);
		};
		if(current_section === 'step-id-3'){
			
			show_step_3();
			check_toolboxes_overflow(1250,400);
		};
		if(current_section === 'step-id-4'){
			
			show_step_4();
			check_toolboxes_overflow(1250,270);
		};
		if(current_section === 'step-id-5'){
			check_toolboxes_overflow_reset();
			show_step_5();
		};
		if(current_section === 'step-id-6'){
			check_toolboxes_overflow_reset();
			show_step_6();
		};
	});
});


/*Step 1*/
function show_step_1(){
	
	jQuery('.funnelkit-editor-helper').hide();
	jQuery('.funnelkit-step-content').hide(animation_mode);
	jQuery('.funnelkit-step-container').removeClass('active');
	jQuery('.funnelkit-step-container.step-id-1').addClass('active');
	jQuery('.funnelkit-step-content.step-no-1').show(animation_mode);
	check_background_type();
}


function check_background_type(){
	var background_type = jQuery('input[name="funnelkit-background-type"]:checked').val();
	if(typeof background_type==='undefined'){
		background_type = defalut_backgroung_type;
		jQuery('input[name="funnelkit-background-type"]').filter('[value="'+background_type+'"]').attr('checked', true);
	}
	
	jQuery(".step-id-1-level-1").hide(animation_mode);
	jQuery(".step-id-1-level-2").hide(animation_mode);
	if (background_type === 'map-satellite' || background_type === 'map-road' || background_type === 'map-satellite-road'){
		jQuery('.step-id-1-background-map-type').show(animation_mode);
		check_map_type();
	}
	if (background_type === 'image'){
		jQuery('.step-id-1-background-image').show(animation_mode);
	}
	if (background_type === 'color-solid'){
		jQuery('.step-id-1-background-color').show(animation_mode);
	}
	if (background_type === 'color-gradient'){
		jQuery('.step-id-1-background-gradient').show(animation_mode);
	}
	if (background_type === 'video'){
		jQuery('.step-id-1-background-video').show(animation_mode);
	}
}

function check_map_type(){
	var map_type = jQuery('input[name="funnelkit-background-map-type"]:checked').val();
	if(typeof map_type==='undefined'){
		map_type = defalut_map_type;
		jQuery('input[name="funnelkit-background-map-type"]').filter('[value="'+map_type+'"]').attr('checked', true);
	}
	
	jQuery(".step-id-1-level-2").hide(animation_mode);
	if (map_type === 'static'){
		jQuery('.step-id-1-background-map-pin').show(animation_mode);
	}
}

jQuery(document).ready(function($){	
	$('input[name="funnelkit-background-type"]').on('click', function(){
		check_background_type();
	});
	
	$('input[name="funnelkit-background-map-type"]').on('click', function(){
		check_map_type();
	});
});

jQuery(document).ready(function($){
    var custom_uploader;
    $('#funnelkit-upload-background-image').click(function(e) {
         e.preventDefault();
        if (custom_uploader) {
            custom_uploader.open();
            return;
        }
        custom_uploader = wp.media.frames.file_frame = wp.media({
            title: 'Choose Image',
            button: {
                text: 'Choose Image'
            },
            multiple: false
        });
        custom_uploader.on('select', function() {
            attachment = custom_uploader.state().get('selection').first().toJSON();
            $('#funnelkit-background-image-url').val(attachment.url);
        });
        custom_uploader.open();
    });
});


/*Step 2*/
function show_step_2(){
	jQuery('.funnelkit-editor-helper').hide();
	jQuery('.funnelkit-step-content').hide(animation_mode);
	jQuery('.funnelkit-step-container').removeClass('active');
	jQuery('.funnelkit-step-container.step-id-2').addClass('active');
	jQuery('.funnelkit-step-content.step-no-2').show(animation_mode);
	jQuery('.helper-step-no-2').show(animation_mode);
	check_layout_settings();
}

jQuery(document).ready(function($){
	$('.step-no-2 input').on('change', function(){check_layout_settings();});
});
jQuery(".helper-step-no-2 .funnelkit-toggle_image, .helper-step-no-2 .funnelkit-toggle_image_off").click(function(){
	$class = jQuery(this).attr("class");
	if($class == "funnelkit-toggle_image") {
		jQuery(this).attr("class","funnelkit-toggle_image_off");
		jQuery(".helper-step-no-2").css("position", "absolute");
	} else {
		jQuery(this).attr("class","funnelkit-toggle_image");
		jQuery(".helper-step-no-2").css("position", "fixed");
	}
});
function check_layout_settings(){
	var funnelkit_layout_width = jQuery('input[name="funnelkit-layout-width"]:checked').val();
	if(typeof funnelkit_layout_width==='undefined'){
		funnelkit_layout_width = defalut_funnelkit_layout_width;
		jQuery('input[name="funnelkit-layout-width"]').filter('[value="'+funnelkit_layout_width+'"]').attr('checked', true);
	}
	if(funnelkit_layout_width==='fixed-width'){
		jQuery('input[name="funnelkit-layout-width-fixed"]').show(animation_mode);
	}else{
		jQuery('input[name="funnelkit-layout-width-fixed"]').hide(animation_mode);
	}
	
	
	var funnelkit_layout_horizontal_position = jQuery('input[name="funnelkit-layout-horizontal-position"]:checked').val();
	if(typeof funnelkit_layout_horizontal_position==='undefined'){
		funnelkit_layout_horizontal_position = defalut_funnelkit_layout_horizontal_position;
		jQuery('input[name="funnelkit-layout-horizontal-position"]').filter('[value="'+funnelkit_layout_horizontal_position+'"]').attr('checked', true);
	}
	if(funnelkit_layout_horizontal_position==='middle'){
		jQuery('input[name="funnelkit-layout-horizontal-position-left"]').hide(animation_mode);
		jQuery('input[name="funnelkit-layout-horizontal-position-right"]').hide(animation_mode);
	}else{
		if(funnelkit_layout_horizontal_position==='left'){
			jQuery('input[name="funnelkit-layout-horizontal-position-left"]').show(animation_mode);
			jQuery('input[name="funnelkit-layout-horizontal-position-right"]').hide(animation_mode);
		}else{
			jQuery('input[name="funnelkit-layout-horizontal-position-left"]').hide(animation_mode);
			jQuery('input[name="funnelkit-layout-horizontal-position-right"]').show(animation_mode);
		}
	}
	
	var funnelkit_layout_vertical_position = jQuery('input[name="funnelkit-layout-vertical-position"]:checked').val();
	if(typeof funnelkit_layout_vertical_position==='undefined'){
		funnelkit_layout_vertical_position = defalut_funnelkit_layout_vertical_position;
		jQuery('input[name="funnelkit-layout-vertical-position"]').filter('[value="'+funnelkit_layout_vertical_position+'"]').attr('checked', true);
	}
	if(funnelkit_layout_vertical_position==='top'){
		jQuery('input[name="funnelkit-layout-vertical-position-top"]').show(animation_mode);
	}else{
		jQuery('input[name="funnelkit-layout-vertical-position-top"]').hide(animation_mode);
	}
	
	
	var funnelkit_layout_outer_glow_enable = jQuery('input[name="funnelkit-layout-outer-glow-enable"]:checked').val();
	if(typeof funnelkit_layout_outer_glow_enable==='undefined'){
		jQuery('.step-id-2-outer-glow-enabled').hide(animation_mode);
	}else{
		jQuery('.step-id-2-outer-glow-enabled').show(animation_mode);
	}
	render_preview_step_2();
}

function render_preview_step_2(){
	var layout_padding = jQuery('input[name="funnelkit-layout-padding"]').val();
	var layout_color = jQuery('input[name="funnelkit-layout-color"]').val();
	var layout_opacity = parseInt(jQuery('input[name="funnelkit-layout-opacity"]').val());
	
	var layout_border_round = jQuery('input[name="funnelkit-layout-border-round"]:checked').val();
	var layout_border_size = jQuery('input[name="funnelkit-layout-border-size"]').val();
	var layout_border_color = jQuery('input[name="funnelkit-layout-border-color"]').val();
	
	var layout_outer_glow_enable = jQuery('input[name="funnelkit-layout-outer-glow-enable"]:checked').val();
	var layout_outer_glow_size = jQuery('input[name="funnelkit-layout-outer-glow-size"]').val();
	var layout_outer_glow_color = jQuery('input[name="funnelkit-layout-outer-glow-color"]').val();
	
	
	
	jQuery('.preview-step-no-2').css('padding', layout_padding+'px');
	if(jQuery('input[name="funnelkit-container-no-bg"]').is(":checked")) {
		jQuery('.preview-step-no-2').css({'background': 'none'});
	} else {
		jQuery('.preview-step-no-2').css('background-color', '#'+layout_color);
	}
	
	
	if(layout_opacity <100){
		var layout_opacity_pro = layout_opacity/100;
		var oldBGColor = jQuery('#funnelkit-layout-color').css('backgroundColor');
		var newBGColor = oldBGColor.replace('rgb', 'rgba').replace(')', ','+layout_opacity_pro+')');
		if(jQuery('input[name="funnelkit-container-no-bg"]').is(":checked")) {
			jQuery('.preview-step-no-2').css({'background': 'none'});
		} else {
			jQuery('.preview-step-no-2').css({'background-color': newBGColor});
		}
	}

	
	
	
	jQuery('.preview-step-no-2').css('border-width', layout_border_size+'px');
	jQuery('.preview-step-no-2').css('border-color', '#'+layout_border_color);
	if(layout_border_round==='on'){
		jQuery('.preview-step-no-2').css('border-radius', '5px');
	}else{
		jQuery('.preview-step-no-2').css('border-radius', '');
	}
	
	
	
	if(layout_outer_glow_enable==='on'){
		var glow = '0px 0px '+layout_outer_glow_size+'px #'+layout_outer_glow_color;
		jQuery('.preview-step-no-2').css('box-shadow', glow);
	}else{
		jQuery('.preview-step-no-2').css('box-shadow', '');
	}
}

/*Step 3*/
function show_step_3(){
	jQuery('.funnelkit-editor-helper').hide();
	jQuery('.funnelkit-step-content').hide(animation_mode);
	jQuery('.funnelkit-step-container').removeClass('active');
	jQuery('.funnelkit-step-container.step-id-3').addClass('active');
	jQuery('.funnelkit-step-content.step-no-3').show(animation_mode);
	jQuery('.helper-step-no-3').show(animation_mode);
	check_custom_styles();
}
jQuery(".helper-step-no-3 .funnelkit-toggle_image, .helper-step-no-3 .funnelkit-toggle_image_off").click(function(){
	$class = jQuery(this).attr("class");
	if($class == "funnelkit-toggle_image") {
		jQuery(this).attr("class","funnelkit-toggle_image_off");
		jQuery(".helper-step-no-3").css("position", "absolute");
	} else {
		jQuery(this).attr("class","funnelkit-toggle_image");
		jQuery(".helper-step-no-3").css("position", "fixed");
	}
});
jQuery(document).ready(function($){	
	$('input[name="funnelkit-subscribion-custom-styles"],input[name="funnelkit-subscribion-data-reach"]').on('click', function(){
		check_custom_styles();
	});
	var submit_button_style = jQuery('input[name="funnelkit-subscribion-submit-button"]').val();
	jQuery('.submit-button-preview').attr('src', submit_button_style);
	
	$('div.ssbs-tabs').tabs();
	
	jQuery('.submit-button-preview').on('load', function(){
		if(jQuery('.funnelkit-subscribion-submit-button-width').val()==='0'){
			jQuery('.funnelkit-subscribion-submit-button-width').val(this.width);
		}
	});
	
	step_3_preview();
	$('.step-no-3 input').on('change', function(){step_3_preview();});
	$('.step-no-3 select').on('change', function(){step_3_preview();});
	
	
});

function step_3_preview(){
	
	var custom_styles = jQuery('input[name="funnelkit-subscribion-custom-styles"]:checked').val();
	
	if(custom_styles!=='on'){return;}
	
	
	var body_color = jQuery('#funnelkit-subscribion-body-color').val();
	var body_padding = jQuery('#funnelkit-subscribion-body-padding').val();
	var body_opacity = jQuery('#funnelkit-subscribion-body-opacity').val();
	
	
	var border_color = jQuery('#funnelkit-subscribion-border-color').val();
	var border_size = jQuery('#funnelkit-subscribion-border-size').val();
	var border_style = jQuery('#funnelkit-subscribion-border-style').val();
		
	var inputs_font_color = jQuery('#funnelkit-subscribion-inputs-font-color').val();
	var inputs_font_size = jQuery('#funnelkit-subscribion-inputs-font-size').val();
	var inputs_font_style = jQuery('#funnelkit-subscribion-inputs-font-style').val();
	
	var fields_width = jQuery('#funnelkit-subscribion-fields-width').val();
	var fields_height = jQuery('#funnelkit-subscribion-fields-height').val();
	var fields_padding = jQuery('#funnelkit-subscribion-fields-padding').val();
	var fields_color = jQuery('#funnelkit-subscribion-fields-color').val();
	var fields_align = jQuery('#funnelkit-subscribion-input-field-align').val();
	
	var fields_border = jQuery('#funnelkit-subscribion-fields-border').val();
	var fields_border_color = jQuery('#funnelkit-subscribion-fields-border-color').val();
	var fields_border_style = jQuery('#funnelkit-subscribion-fields-border-style').val();
	
	var submit_button = jQuery('#funnelkit-subscribion-submit-button').val();
	var submit_button_align = jQuery('#funnelkit-subscribion-submit-button-aligh').val();
	
	var submit_button_style = jQuery('input[name="funnelkit-subscribion-submit-button"]').val();
	jQuery('.submit-button-preview').attr('src', submit_button_style);
	
	jQuery('#step-3-form').css('padding', body_padding);
	if(jQuery('input[name="funnelkit-form-no-bg"]').is(":checked")) {
		jQuery('#step-3-form').css('background', 'none');
	} else {
		jQuery('#step-3-form').css('background', '#'+body_color);
	}
	
	if(body_opacity <100){
		var layout_opacity_pro = body_opacity/100;
		var oldBGColor = jQuery('#funnelkit-subscribion-body-color').css('backgroundColor');
		var newBGColor = oldBGColor.replace('rgb', 'rgba').replace(')', ','+layout_opacity_pro+')');
		jQuery('#step-3-form').css({'background-color': newBGColor});
	}
	jQuery('#step-3-form').css('border-color','#'+border_color).css('border-width',border_size+'px').css('border-style',border_style);
	
	
	jQuery('#step-3-form input[type="text"]').css('color', '#'+inputs_font_color).css('font-size', inputs_font_size+'px').css('font-family', inputs_font_style).
	css("font-style",jQuery("#funnelkit-subscribion-inputs-font-styling").val()).
	css("font-weight",jQuery("#funnelkit-subscribion-inputs-font-weight").val()).
	css("text-decoration",jQuery("#funnelkit-subscribion-inputs-text-decoration").val()).
	css("text-align",jQuery("#funnelkit-subscribion-inputs-text-align").val());
	
	if(fields_width>380){fields_width = 380;}
	jQuery('#step-3-form  input[type="text"]').css('width', fields_width+'px').css('height', fields_height+'px').css('padding',fields_padding+'px').css('background','#'+fields_color);

	jQuery('#step-3-form  input[type="text"]').css('border-color','#'+fields_border_color).css('border-width',fields_border+'px').css('border-style',fields_border_style);
	
	var fields_align = jQuery('#funnelkit-subscribion-input-field-align').val();

	jQuery.each(jQuery('#step-3-form  input[type="text"]'), function(key,item){
		if(fields_align != "center" && jQuery(item).parent().get(0).tagName == "CENTER") {
			var cnt = jQuery(jQuery(item).parent().get(0)).contents();
			jQuery($(item).parent().get(0)).replaceWith(cnt);
			jQuery(item).css("float", fields_align);
		} else if(fields_align == "center" && jQuery(item).parent().get(0).tagName != "CENTER") {
			jQuery(item).css("float", "none");
			jQuery(item).wrap("<center></center>");
		} else {
		   jQuery(item).css("float", fields_align);
		}
	}); 
	
	
	if (typeof submit_button == 'undefined') {
		var submit_button = jQuery('#funnelkit-subscribion-submit-button').val();
	}
	if(submit_button.length>0){
		var preview_width = jQuery('.submit-button-preview').width();
		var preview_height = jQuery('.submit-button-preview').height();
		jQuery('#step-3-form').find('input[type="image"]').attr('src', submit_button).attr("width",jQuery("#funnelkit-subscribion-submit-button-width").val()+"px");
		jQuery('#step-3-form').find('input[type="image"]').css('text-indent', '-1000px');
		if(jQuery('input[name="funnelkit-form-no-bg"]').is(":checked")) {
			//jQuery('#step-3-form').find('input[type="image"]').css('background-color','none')
		} else {
			//jQuery('#step-3-form').find('input[type="image"]').css('background-color','#'+body_color);
		}
		jQuery('#step-3-form').find('input[type="image"]').css('border','none');
		
		
		if(submit_button_align != "center" && jQuery('#step-3-form').find('input[type="image"]').parent().get(0).tagName == "CENTER") {
			var cnt = $(jQuery('#step-3-form').find('input[type="image"]').parent().get(0)).contents();
			$(jQuery('#step-3-form').find('input[type="image"]').parent().get(0)).replaceWith(cnt);
			jQuery('#step-3-form').find('input[type="image"]').css("float", submit_button_align);
		} else if(submit_button_align == "center" && jQuery('#step-3-form').find('input[type="image"]').parent().get(0).tagName != "CENTER") {
			jQuery('#step-3-form').find('input[type="image"]').css("float", "none");
			jQuery('#step-3-form').find('input[type="image"]').wrap("<center></center>");
		} else {
		   jQuery('#step-3-form').find('input[type="image"]').css("float", submit_button_align);
		}
		jQuery('#step-3-form').find('input[type="image"]').css("margin-top", jQuery("#funnelkit-subscribion-submit-button-margin-top").val()+"px")
		.css("margin-bottom", jQuery("#funnelkit-subscribion-submit-button-margin-bottom").val()+"px");
	}
	
}

function check_custom_styles(){
	var custom_styles = jQuery('input[name="funnelkit-subscribion-custom-styles"]:checked').val();
	var show_obj = jQuery('input[name="funnelkit-subscribion-data-reach"]:checked').val() == "on" ? true : false;
	if(show_obj) {
		jQuery("#tool-data-reach").show();
		jQuery("#tool-optin-form").hide();
	} else {
		jQuery("#tool-data-reach").hide();
		jQuery("#tool-optin-form").show();
	}
	if(custom_styles != "on" && show_obj == false) {
		jQuery("#tool-data-reach").hide();
	}
	
	if(custom_styles == "on") {
		jQuery('.helper-step-no-3').show(animation_mode);
		jQuery('#funnelkit-subscribion-data-reach').hide(animation_mode);
	} else {
		jQuery('.helper-step-no-3').hide(animation_mode);
		jQuery('#funnelkit-subscribion-data-reach').show(animation_mode);
	}
	if(jQuery('input[name="funnelkit-subscribion-data-reach"]:checked').val() == "on") {
		jQuery("#funnelkit-subscribion-custom-styles").hide(animation_mode);
		
	} else {
		jQuery("#funnelkit-subscribion-custom-styles").show(animation_mode);
	}
	if(jQuery('input[name="funnelkit-subscribion-custom-styles"]').attr('checked')==='checked'){
		jQuery('.step-id-3-level-1').show(animation_mode);
		jQuery('#funnelkit-subscribion-data-reach').hide(animation_mode);
	}else{
		jQuery('.step-id-3-level-1').hide(animation_mode);
		jQuery('#funnelkit-subscribion-data-reach').show(animation_mode);
	}
}

function submit_button_popup_show(){
	jQuery('.funnelkit-subscribion-submit-button-popup').show();
}

function submit_button_popup_close(){
	jQuery('.funnelkit-subscribion-submit-button-popup').hide();
}

function submit_button_popup_save(){
	var submit_button_style = jQuery('input[name="button_style"]:checked').val();
	jQuery('input[name="funnelkit-subscribion-submit-button"]').val(submit_button_style);
	jQuery('.submit-button-preview').attr('src', submit_button_style);
	submit_button_popup_close();
	step_3_preview();
}



/*Step 4*/
function show_step_4(){
	check_custom_styles();
	jQuery('.funnelkit-editor-helper').hide();
	jQuery('.funnelkit-step-content').hide(animation_mode);
	jQuery('.funnelkit-step-container').removeClass('active');
	jQuery('.funnelkit-step-container.step-id-4').addClass('active');
	jQuery('.funnelkit-step-content.step-no-4').show(animation_mode);
	jQuery('.helper-step-no-4').show(animation_mode);
}
jQuery(".helper-step-no-4 .funnelkit-toggle_image, .helper-step-no-4 .funnelkit-toggle_image_off").click(function(){
	$class = jQuery(this).attr("class");
	if($class == "funnelkit-toggle_image") {
		jQuery(this).attr("class","funnelkit-toggle_image_off");
		jQuery(".helper-step-no-4").css("position", "absolute");
	} else {
		jQuery(this).attr("class","funnelkit-toggle_image");
		jQuery(".helper-step-no-4").css("position", "fixed");
	}
});
jQuery(".funnelkit-editor-title .funnelkit-toggle_image, .funnelkit-editor-title .funnelkit-toggle_image_off").click(function(){
	$class = jQuery(this).attr("class");
	if($class == "funnelkit-toggle_image") {
		jQuery(this).attr("class","funnelkit-toggle_image_off");
		jQuery(".editor-element-header, .delete-button, .settings-button,[id^=connector-]").slideUp();
	} else {
		jQuery(this).attr("class","funnelkit-toggle_image");
		jQuery(".editor-element-header, .delete-button, .settings-button,[id^=connector-]").slideDown();
	}
});


function check_dialog_preview_image(){
	var new_url = jQuery('.active #coll_image_url').val();
	if (typeof new_url === 'undefined' || new_url.length == 0){
		var new_url = jQuery(".active #coll_image_hotlink_url").val();
		if (typeof new_url === 'undefined'){
			return;
		}
	}
	if(new_url.length>0){
		jQuery('.active .preview_coll_image').attr('src', new_url);
		photograf = new Image();
		photograf.onload = function() {
			jQuery(".active #coll_image_width").val(photograf.width);
			jQuery(".active #coll_image_height").val(photograf.height);
		}
		photograf.src = new_url;
	}
}


jQuery(document).ready(function($){
    var custom_coll_uploader;
    $('input[name="coll_image_url_button"]').click(function(e) {
		
         e.preventDefault();
        if (custom_coll_uploader) {
            custom_coll_uploader.open();
            return;
        }
        custom_coll_uploader = wp.media.frames.file_frame = wp.media({
            title: 'Choose Image',
            button: {
                text: 'Choose Image'
            },
            multiple: false
        });
        custom_coll_uploader.on('select', function() {
            var attachment = custom_coll_uploader.state().get('selection').first().toJSON();
            $('.active #coll_image_url').val(attachment.url);
			$('.active #coll_image_height').val(attachment.height);
			$('.active #coll_image_width').val(attachment.width);

			check_dialog_preview_image();
        });
        custom_coll_uploader.open();
		
    });
	
	$('input[name="coll_image_url"], input[name="coll_image_hotlink_url"]').on('change', function(){
		check_dialog_preview_image();
	});
});


/*Step 5*/
function show_step_5(){
	jQuery('.funnelkit-editor-helper').hide();
	jQuery('.funnelkit-step-content').hide(animation_mode);
	jQuery('.funnelkit-step-container').removeClass('active');
	jQuery('.funnelkit-step-container.step-id-5').addClass('active');
	jQuery('.funnelkit-step-content.step-no-5').show(animation_mode);
	check_callouts_status();
}
jQuery(document).ready(function($){
	$('.step-no-5 input').on('click', function(){check_callouts_status();});
	$('.step-no-5 select').on('change', function(){check_callouts_status();});
});

function check_callouts_status(){
	if(jQuery('input[name="funnelkit-callout-enabled"]').attr('checked')==='checked'){
		jQuery('.step-id-5-level-1').show(animation_mode);
	}else{
		jQuery('.step-id-5-level-1').hide(animation_mode);
	}
	
	
	var callout_count =  jQuery('select[name="funnelkit-callout-count"]').val();
	jQuery('.callout-editor-container').hide();
	var elements = jQuery('.callout-editor-container');
	for(var i=0;i<callout_count;i++){
		jQuery(elements[i]).show();
	}
	
	
	var funnelkit_callout_position = jQuery('input[name="funnelkit-callout-position"]:checked').val();
	if(typeof funnelkit_callout_position==='undefined'){
		funnelkit_callout_position = defalut_funnelkit_callout_position;
		jQuery('input[name="funnelkit-callout-position"]').filter('[value="'+funnelkit_callout_position+'"]').attr('checked', true);
	}
	
	
}

/*Step 6*/
function show_step_6(){
	jQuery('.funnelkit-editor-helper').hide();
	jQuery('.funnelkit-step-content').hide(animation_mode);
	jQuery('.funnelkit-step-container').removeClass('active');
	jQuery('.funnelkit-step-container.step-id-6').addClass('active');
	jQuery('.funnelkit-step-content.step-no-6').show(animation_mode);
	check_exit_message_status();
	check_exit_message_status_2();
}

jQuery(document).ready(function($){
	$('.step-no-6 input').on('click', function(){check_exit_message_status();});
	$('.step-no-6 input').on('click', function(){check_exit_message_status_2();});
});

function check_exit_message_status(){
	if(jQuery('input[name="funnelkit-exit-message-enabled"]').attr('checked')==='checked'){
		jQuery('.funnelkit-exit-message-content').show(animation_mode);
	}else{
		jQuery('.funnelkit-exit-message-content').hide(animation_mode);
	}
}
function check_exit_message_status_2(){
	if(jQuery('input[name="funnelkit-exit-message-old-enabled"]').attr('checked')==='checked'){
		jQuery('.funnelkit-exit-message-old-content').show(animation_mode);
	}else{
		jQuery('.funnelkit-exit-message-old-content').hide(animation_mode);
	}
}


/*Global*/

/*Dialogs*/

function show_dialog(){
	jQuery('.funnelkit-dialog-wrap').remove();
	jQuery('body').append('<div class="funnelkit-dialog-wrap aplha60"><div class="funnelkit-dialog-container"></div></div>');
}

function close_dialog(){
	jQuery('.funnelkit-dialog-wrap').remove();
}

function load_save_request(){
	jQuery('.funnelkit-dialog-container').empty().append('<div class="funnelkit-dialog-header">Save Page</div>');
	jQuery('.funnelkit-dialog-container').append('<div class="funnelkit-dialog-content">Type name of page:<br/><input size="40" type="text" name="dialog-save-post-name" /></div>');
	jQuery('.funnelkit-dialog-container').append('<div class="funnelkit-dialog-buttons"><div class="funnelkit-button funnelkit-button-red" onclick="close_dialog();">Return</div><div class="funnelkit-button funnelkit-button-blue" onclick="continue_saving();">Save</div</div>');
	jQuery('.funnelkit-dialog-container').css('height', '200px').css('width', '400px');
}

function init_saving(){
	tinyMCE.triggerSave();
	var pagename = jQuery('input[name="funnelkit-page-name"]').val();
	if(pagename.length > 0){
		continue_saving();
	}else{
		show_dialog();
		load_save_request();
	}
}
function init_quick_saving(){
	tinyMCE.triggerSave();
	var pagename = jQuery('input[name="funnelkit-page-name"]').val();
	if(pagename.length > 0){
		continue_quick_saving();
	}else{
		show_dialog();
		load_save_request();
	}
}
function continue_saving(){
	var new_postname = jQuery('input[name="dialog-save-post-name"]').val();
	if(typeof new_postname !== 'undefined'){
		if(new_postname.length > 0){
			jQuery('input[name="funnelkit-page-name"]').val(jQuery('input[name="dialog-save-post-name"]').val());
		}
	}
	jQuery('#main-form').submit();
}
function continue_quick_saving(){
	var new_postname = jQuery('input[name="dialog-save-post-name"]').val();
	if(typeof new_postname !== 'undefined'){
		if(new_postname.length > 0){
			jQuery('input[name="funnelkit-page-name"]').val(jQuery('input[name="dialog-save-post-name"]').val());
		}
	}
	jQuery.post(ajaxurl+'?action=funnelkit_quicksave', jQuery("#main-form").serialize(), function (result) {
		if(result == "OK") {
			alert("Page Saved");
		} else {
			alert("Saving Failed!");
		}
	});
}
function make_preview() {
	jQuery(".funnelkit-loading").show();
	jQuery.post('../?funnelkit_preview=true', jQuery("#main-form").serialize(), function (result) {
		console.log(result);
        jQuery.fancybox.open([
		    {
		        href : result,
		        title : 'Preview'
		    }   
		], {
		    padding : 0,
		    width: "90%",
		    height: "100%",
		    type : 'iframe'
		});
    });
    jQuery(".funnelkit-loading").hide();
}

function attempt_reset() {
	var c = confirm("Reset all the changes? This CANNOT be undone!");
	if(c == true) {
		location.reload(); 
	}
}
function check_toolboxes_overflow(min_width,item_width) {
	check_toolboxes_overflow_reset();
	
	if(jQuery( window).width() < min_width) {
		jQuery(".funnelkit-editor-helper").css("float","right").css("right","0").css("position","static");
		jQuery(".wrap").css("width",(item_width == 400 ? "1170" : "1040"));
	} else {
		check_toolboxes_overflow_reset();
	}
}
function check_toolboxes_overflow_reset() {
	var margin_left = jQuery(".funnelkit-editor-header").offset().left+jQuery(".funnelkit-editor-header").width()+10;
	jQuery(".funnelkit-editor-helper:visible").css('left',margin_left);
	jQuery(".funnelkit-editor-helper").css("float","none").css("position","fixed");
	jQuery(".wrap").css("width","auto");
}

jQuery( window ).resize(function() {
	var current_section = jQuery(".funnelkit-step-navigator .active").attr("id");
	if(current_section === 'step-id-1'){	
		check_toolboxes_overflow_reset();
	};
	if(current_section === 'step-id-2'){
		check_toolboxes_overflow(1250,400);
	};
	if(current_section === 'step-id-3'){
		console.log("fire");
		check_toolboxes_overflow(1250,400);
	};
	if(current_section === 'step-id-4'){
		check_toolboxes_overflow(1250,270);
	};
	if(current_section === 'step-id-5'){
		check_toolboxes_overflow_reset();
	};
	if(current_section === 'step-id-6'){
		check_toolboxes_overflow_reset();
	};
});
/*
jQuery( document ).ready(function() {
	if(jQuery( document).width() < 1251) {
		jQuery(".funnelkit-editor-helper").css("float","right").css("right","0").css("position","static");
		jQuery(".wrap").css("width","1040px");
	}
});
jQuery( window ).resize(function() {
	if(jQuery( window).width() < 1251) {
		jQuery(".funnelkit-editor-helper").css("float","right").css("right","0").css("position","static");
		jQuery(".wrap").css("width","1040px");
	} else if(jQuery( document).width() > 1252) {
		jQuery(".funnelkit-editor-helper").css("float","none").css("right","20px").css("position","fixed");
		jQuery(".wrap").css("width","auto");

	}
});
*/