var FunnelKit = FunnelKit || {};
FunnelKit.Editor = FunnelKit.Editor || {};
var con_id = 0;
var block_id = 0;
var currentElement = {};

(function($){
	"use strict";
	FunnelKit.Editor = function (opts){
			
		var self = this;
		
		var options = $.extend({ 
			tools_container: '.funnelkit-helper-panel',
			editor_container:'.funnelkit-content-editor'
		}, opts );
		
		self.init = function(){
			self.renderToolbar();
			self.renderEditor();
			self.setupEvents();
		};
		
		self.setupEvents = function(){
			$('.tools-item, .funnelkit-connectors').unbind('sort');
			$(".tools-item, .funnelkit-connectors").sortable({
				connectWith:'.funnelkit-connectors',
				helper: "clone",
				stop: function( event, ui ) {
					var current_class = ui.item[0].className;
					var connector_id = $('.'+current_class).parent('.funnelkit-connectors').attr('id');
					self.addItem(current_class, connector_id);
					return false;
				}
			});			
			//editor-element
			$('.settings-button').on('click', function(){
				var section_indentificator = $(this).parent('.editor-element').attr('id');
				var section_id = parseInt(section_indentificator.replace('block_',''));
				currentElement = {};
				block_id = 0;
				var ced = $.parseJSON($('#editor-content').html());
				self.getElement(ced.childs[0], section_id);
				if(typeof(currentElement.title)!=='undefined'){
					self.showSettingsDialog(section_id);
				}
			});
			$('.delete-button').on('click', function(){
				var r=confirm("Delete section with all subsections?");
				if (r===true){
					var current_section = parseInt(jQuery(this).attr("data-id"));
					self.removeSection(current_section);
					jQuery('.dialog_prototypes').hide();
					jQuery('.dialog_prototypes .active').hide().removeClass('active');
				}
			});
			
			
			/*$('.move-button').on('mousedown', function(){
				var section_indentificator = $(this).parent('.editor-element').attr('id');
				var section_id = parseInt(section_indentificator.replace('block_',''));
				currentElement = {};
				block_id = 0;
				var ced = $.parseJSON($('#editor-content').html());
				self.getElement(ced.childs[0], section_id);
				var moved_element = currentElement;
				
		//		debugger;
				
				
				self.removeSection(section_id);
			});
			*/
			
		};
		
		self.showSettingsDialog = function(section_id){
			$('.funnelkit-button').unbind('click');
			$('.funnelkit-popup-info').unbind('change');
			jQuery('.dialog_prototypes').show();
			
			if(currentElement.type === '1-coll-element'){
				jQuery('.coll-1-settings').show().addClass('active');
			}
			if(currentElement.type === '2-coll-element'){
				jQuery('.coll-2-settings').show().addClass('active');
			}
			if(currentElement.type === '3-coll-element'){
				jQuery('.coll-3-settings').show().addClass('active');
			}
			
			if(currentElement.type === 'text-element'){
				jQuery('.text-element').show().addClass('active');
			}
			
			if(currentElement.type === 'text-image-left-element'){
				jQuery('.text-image-left-element').show().addClass('active');
			}
			
			if(currentElement.type === 'text-image-right-element'){
				jQuery('.text-image-right-element').show().addClass('active');
			}
			
			if(currentElement.type === 'image-element'){
				jQuery('.image-element').show().addClass('active');
			}
			if(currentElement.type === 'optin-form-element'){
				jQuery('.optin-form-element').show().addClass('active');
			}
			if(currentElement.type === 'data-reach-element'){
				jQuery('.data-reach-element').show().addClass('active');
			}
			if(currentElement.type === 'video-element'){
				jQuery('.video-element').show().addClass('active');
			}
		
				
			self.fillDialogForm(section_id);
			self.eventsDialogForm();
			$('.active').on('change', function(){
					self.eventsDialogForm();
			});
				

			$('.active .dialog-return').on('click', function(){
				jQuery('.dialog_prototypes').hide();
				jQuery('.dialog_prototypes .active').hide().removeClass('active');
			});

			$('.active .dialog-delete').on('click', function(){
				var r=confirm("Delete section with all subsections?");
				if (r===true){
					var current_section = parseInt(jQuery('.active #funnelkit_dialog_id').val());
					self.removeSection(current_section);
					jQuery('.dialog_prototypes').hide();
					jQuery('.dialog_prototypes .active').hide().removeClass('active');
				}
			});
			
			$('.active .dialog-save').on('click', function(){
				var current_section = parseInt(jQuery('.active #funnelkit_dialog_id').val());
				self.updateSection(current_section);
				jQuery('.dialog_prototypes').hide();
				jQuery('.dialog_prototypes .active').hide().removeClass('active');
			});

		};
		
		self.fillDialogForm = function(section_id){
			var el = currentElement;
			
			if(typeof el.coll_width_type==='undefined'){el.coll_width_type = 'full';}
			if(typeof el.coll_fixed_width_type==='undefined'){el.coll_fixed_width_type = 'fixed-pixels';}
			if(typeof el.coll_fixed_width_pixels==='undefined'){el.coll_fixed_width_pixels = '980';}
			if(typeof el.coll_fixed_width_percent==='undefined'){el.coll_fixed_width_percent = '100';}
			if(typeof el.coll_background_color==='undefined'){el.coll_background_color = 'FFFFFF';}
			if(typeof el.coll_border_size==='undefined'){el.coll_border_size = '0';}
			if(typeof el.coll_border_color==='undefined'){el.coll_border_color = 'FFFFFF';}
			if(typeof el.coll_padding==='undefined'){el.coll_padding = '0';}
			
			if(typeof el.coll_image_url==='undefined'){el.coll_image_url = '';}
			
			if(typeof el.coll_image_hotlink_url==='undefined'){el.coll_image_hotlink_url = '';}
			if(typeof el.coll_image_url_hotlink_target==='undefined'){el.coll_image_url_hotlink_target = '';}
			
			if(typeof el.coll_image_width==='undefined'){el.coll_image_width = '0';}
			if(typeof el.coll_image_height==='undefined'){el.coll_image_height = '0';}
			if(typeof el.coll_image_padding==='undefined'){el.coll_image_padding = '0';}
			if(typeof el.coll_image_align==='undefined'){el.coll_image_align = 'center';}
			
			
			if(typeof el.coll_video_type==='undefined'){el.coll_video_type = 'youtube';}
			
			
			if(typeof el.coll_video_youtube_id==='undefined'){el.coll_video_youtube_id = '';}
			if(typeof el.coll_video_youtube_width==='undefined'){el.coll_video_youtube_width = '';}
			if(typeof el.coll_video_youtube_align==='undefined'){el.coll_video_youtube_align = 'center';}
			
			if(typeof el.coll_align==='undefined'){el.coll_align = 'left';}
			if(typeof el.coll_form_align==='undefined'){el.coll_form_align = 'left';}
			
			
			if(typeof el.coll_video_embed_code==='undefined'){
				el.coll_video_embed_code = '';
			}else{
				el.coll_video_embed_code = Base64.decode(el.coll_video_embed_code);
			}
			if(typeof el.coll_video_embed_align==='undefined'){el.coll_video_embed_align = 'center';}

			
			if(typeof el.text_element!=='undefined'){
				tinymce.editors['text_element'].setContent(Base64.decode(el.text_element));
			}
			if(typeof el.text_image_left_element!=='undefined'){
				tinymce.editors['text_image_left_element'].setContent(Base64.decode(el.text_image_left_element));
			}
			if(typeof el.text_image_right_element!=='undefined'){
				tinymce.editors['text_image_right_element'].setContent(Base64.decode(el.text_image_right_element));
			}
			
			
			if(typeof el.coll_ratio_padding_1==='undefined'){el.coll_ratio_padding_1 = '0';}
			if(typeof el.coll_ratio_padding_2==='undefined'){el.coll_ratio_padding_2 = '0';}
			
			
			if(el.type === '2-coll-element'){
				if(typeof el.coll_ratio_left==='undefined'){el.coll_ratio_left = '50';}

				if(typeof el.coll_ratio_middle==='undefined'){el.coll_ratio_middle = '';}
				if(typeof el.coll_ratio_right==='undefined'){el.coll_ratio_right = '50';}
			}else{
				if(typeof el.coll_ratio_left==='undefined'){el.coll_ratio_left = '33';}
				if(typeof el.coll_ratio_middle==='undefined'){el.coll_ratio_middle = '33';}
				if(typeof el.coll_ratio_right==='undefined'){el.coll_ratio_right = '33';}
			}

			jQuery('.active input[name="funnelkit_dialog_id"]').val(section_id);
			jQuery('.active input[name="coll_width_type"]').filter('[value="'+el.coll_width_type+'"]').attr('checked', true);
			jQuery('.active input[name="coll_fixed_width_type"]').filter('[value="'+el.coll_fixed_width_type+'"]').attr('checked', true);
			jQuery('.active input[name="coll_fixed_width_pixels"]').val(el.coll_fixed_width_pixels);
			jQuery('.active input[name="coll_fixed_width_percent"]').val(el.coll_fixed_width_percent);
			jQuery('.active input[name="coll_border_size"]').val(el.coll_border_size);
			jQuery('.active input[name="coll_padding"]').val(el.coll_padding);
			jQuery('.active input[name="coll_background_color"]').val(el.coll_background_color);
			jQuery('.active input[name="coll_border_color"]').val(el.coll_border_color);
			
			jQuery('.active input[name="coll_ratio_left"]').val(el.coll_ratio_left);
			jQuery('.active input[name="coll_ratio_middle"]').val(el.coll_ratio_middle);
			jQuery('.active input[name="coll_ratio_right"]').val(el.coll_ratio_right);
			
			jQuery('.active input[name="coll_ratio_padding_1"]').val(el.coll_ratio_padding_1);
			jQuery('.active input[name="coll_ratio_padding_2"]').val(el.coll_ratio_padding_2);
			
			jQuery('.active input[name="coll_image_url"]').val(el.coll_image_url);
			jQuery('.active input[name="coll_image_width"]').val(el.coll_image_width);
			jQuery('.active input[name="coll_image_height"]').val(el.coll_image_height);
			jQuery('.active input[name="coll_image_padding"]').val(el.coll_image_padding);
			jQuery('.active select[name="coll_image_align"]').val(el.coll_image_align);
			
			jQuery('.active select[name="coll_align"]').val(el.coll_align);
			jQuery('.active select[name="coll_form_align"]').val(el.coll_form_align);
			jQuery('.active input[name="coll_height"]').val(el.coll_height);
			
			jQuery('.active input[name="coll_video_youtube_id"]').val(el.coll_video_youtube_id);
			jQuery('.active input[name="coll_video_youtube_width"]').val(el.coll_video_youtube_width);
			jQuery('.active select[name="coll_video_youtube_align"]').val(el.coll_video_youtube_align);
			
			jQuery('.active input[name="coll_image_hotlink_url"]').val(el.coll_image_hotlink_url);
			jQuery('.active input[name="coll_image_url_hotlink_target"]').val(el.coll_image_url_hotlink_target);
			
			jQuery('.active .coll_video_embed_code').val(el.coll_video_embed_code);
			jQuery('.active select[name="coll_video_embed_align"]').val(el.coll_video_embed_align);
			
			
			jQuery('.active input[name="coll_video_type"]').filter('[value="'+el.coll_video_type+'"]').attr('checked', true);

			if(typeof el.coll_no_background_color!=='undefined' && el.coll_no_background_color==='true'){
				jQuery('.active input[name="coll_no_background_color"]').attr('checked', true);
			}else{
				jQuery('.active input[name="coll_no_background_color"]').removeAttr('checked');
			}	
			if(typeof el.coll_round_conners!=='undefined' && el.coll_round_conners === 'true'){
				jQuery('.active input[name="coll_round_conners"]').attr('checked', true);
			}else{
				jQuery('.active input[name="coll_round_conners"]').removeAttr('checked');
			}
			if(typeof el.coll_video_youtube_autostart!=='undefined' && el.coll_video_youtube_autostart === 'true'){
				jQuery('.active input[name="coll_video_youtube_autostart"]').attr('checked', true);
			}else{
				jQuery('.active input[name="coll_video_youtube_autostart"]').removeAttr('checked');
			}

			check_dialog_preview_image();
		};
		
		self.eventsDialogForm = function(){
			if(jQuery('.active input[name="coll_width_type"]:checked').val()==='full'){
				jQuery('.active .dialog-coll-width-fixed').hide();
			}else{
				jQuery('.active .dialog-coll-width-fixed').show();
			}
			
			if(jQuery('.active input[name="coll_video_type"]:checked').val()==='youtube'){
				jQuery('.active .funnelkit-dialog-section.youtube_video').show();
				jQuery('.active .funnelkit-dialog-section.embed_code').hide();
			}else{
				jQuery('.active .funnelkit-dialog-section.youtube_video').hide();
				jQuery('.active .funnelkit-dialog-section.embed_code').show();
			}
		};
		

		
		self.getElement = function(elements, section_id){
			for (var sid = 0; sid < elements.length; sid++){
				
				if(block_id===section_id){
					currentElement = elements[sid];
				}
				block_id++;

				if(elements[sid].type === '1-coll-element'){
					if(elements[sid].childs[0].length!==0){
						self.getElement(elements[sid].childs[0], section_id);
					}
				}
				
				if(elements[sid].type === '2-coll-element'){
					for (var i = 0; i < 2; i++){
						if(elements[sid].childs[i].length!==0){
							self.getElement(elements[sid].childs[i], section_id);
						}
					}
				}
				
				if(elements[sid].type === '3-coll-element'){
					for (var i = 0; i < 3; i++){
						if(elements[sid].childs[i].length!==0){
							self.getElement(elements[sid].childs[i], section_id);
						}
					}
				}
			}
		};
		
		self.renderEditor = function(){
			con_id = 0;
			block_id = 0;
			var editorObj = $.parseJSON( $('#editor-content').html() );
			
			if(editorObj === null){
				var childs = [];
				childs[0]=[];
				editorObj = {'type':'content','is_container':true, 'childs_count': 1,'childs':childs};
			}

			if(editorObj.childs[0].length===0){
				$(options.editor_container).empty().append('<div class="funnelkit-connectors" id="connector-'+con_id+'">Put new section here</div>');
				con_id++;
			}else{
				$(options.editor_container).empty().append('<div class="funnelkit-connectors" id="connector-'+con_id+'">Put new section here</div>');				
				con_id++;
				$(options.editor_container).append(self.renderSubEditor(editorObj.childs[0]));
				$(options.editor_container).append('<div class="funnelkit-connectors" id="connector-'+con_id+'">Put new section here</div>');
				con_id++;
			}
		};
		
		self.renderSubEditor = function (elements){
			
			var code = '';
			
			for (var sid = 0; sid < elements.length; sid++){
			
				code = code + "<div class='editor-element' id='block_"+block_id+"'><div class='editor-element-header'>"+elements[sid].title+"</div><!--div class='move-button'></div--><div data-id='"+block_id+"' class='delete-button'></div><div class='settings-button'></div><div class='editor-element-content'>";
				block_id++;

				if(elements[sid].type === '1-coll-element'){
					code = code + '<div class="dd-1-coll-element-coll" style="">';
					if(elements[sid].childs[0].length===0){
						code = code + '<div class="funnelkit-connectors" id="connector-'+con_id+'">Put new section here</div>';
						con_id++;
					}else{
						code = code + '<div class="funnelkit-connectors" id="connector-'+con_id+'">Put new section here</div>';
						con_id++;
						code = code + self.renderSubEditor(elements[sid].childs[0]);
						code = code + '<div class="funnelkit-connectors" id="connector-'+con_id+'">Put new section here</div>';
						con_id++;
					}
					code = code + '</div>';
				}
				
				if(elements[sid].type === '2-coll-element'){
					for (var i = 0; i < 2; i++){
						code = code + '<div class="dd-2-coll-element-coll" style="">';
						
						if(elements[sid].childs[i].length===0){
							code = code + '<div class="funnelkit-connectors" id="connector-'+con_id+'">Put new section here</div>';
							con_id++;
						}else{
							code = code + '<div class="funnelkit-connectors" id="connector-'+con_id+'">Put new section here</div>';
							con_id++;
							code = code + self.renderSubEditor(elements[sid].childs[i]);
							code = code + '<div class="funnelkit-connectors" id="connector-'+con_id+'">Put new section here</div>';
							con_id++;
						}
						code = code + '</div>';
					}
					code = code + '<div class="clear"></div>';
				}
				
				
				if(elements[sid].type === '3-coll-element'){
					for (var i = 0; i < 3; i++){
						code = code + '<div class="dd-3-coll-element-coll" style="">';
						
						if(elements[sid].childs[i].length===0){
							code = code + '<div class="funnelkit-connectors" id="connector-'+con_id+'">Put new section here</div>';
							con_id++;
						}else{
							code = code + '<div class="funnelkit-connectors" id="connector-'+con_id+'">Put new section here</div>';
							con_id++;
							code = code + self.renderSubEditor(elements[sid].childs[i]);
							code = code + '<div class="funnelkit-connectors" id="connector-'+con_id+'">Put new section here</div>';
							con_id++;
						}
						code = code + '</div>';
					}
					code = code + '<div class="clear"></div>';
				}
				
				
				if(elements[sid].type === 'text-element'){
					code = code + '<div class="dd-text-element" style="">';
					
					if(elements[sid].text_element.length>0){
						code = code + Base64.decode(elements[sid].text_element);
					}
					code = code + '</div>';
				}
				
				if(elements[sid].type === 'text-image-left-element'){
					code = code + '<div class="dd-text-image-left-element" style="">';
					
					if(elements[sid].coll_image_url.length>0){
						code = code + "<img src='"+elements[sid].coll_image_url+"' style='float:left;width:"+elements[sid].coll_image_width+"px;height:"+elements[sid].coll_image_height+"px; padding:0 "+elements[sid].coll_image_padding+"px "+elements[sid].coll_image_padding+"px 0;' />";
					}
					if(elements[sid].text_image_left_element.length>0){
						code = code + Base64.decode(elements[sid].text_image_left_element);
					}
					code = code + '<div class="clear"></div>';
					code = code + '</div>';
				}
				if(elements[sid].type === 'text-image-right-element'){
					code = code + '<div class="dd-text-image-right-element" style="">';
					
					if(elements[sid].coll_image_url.length>0){
						code = code + "<img src='"+elements[sid].coll_image_url+"' style='float:right;width:"+elements[sid].coll_image_width+"px;height:"+elements[sid].coll_image_height+"px; padding:0 0 "+elements[sid].coll_image_padding+"px "+elements[sid].coll_image_padding+"px;' />";
					}
					if(elements[sid].text_image_right_element.length>0){
						code = code + Base64.decode(elements[sid].text_image_right_element);
					}
					code = code + '<div class="clear"></div>';
					code = code + '</div>';
				}
				
				if(elements[sid].type === 'image-element'){
					code = code + '<div class="dd-image-element" style="">';
					
					if(elements[sid].coll_image_url.length>0){
						code = code + "<img src='"+elements[sid].coll_image_url+"' style='width:"+elements[sid].coll_image_width+"px;height:"+elements[sid].coll_image_height+"px;display:block;margin:0 auto;' />";
					} else {
						code = code + "You can select an image by clicking the gear button above";
					}
					code = code + '<div class="clear"></div>';
					code = code + '</div>';
				}
				
				if(elements[sid].type === 'optin-form-element'){
					code = code + '<div class="dd-optin-form-element" style="display:none;">';
					code = code + "<img src='"+rel_path+"/resources/dd-editor/images/button-optin-form.png' style='display:block;margin:0 auto;' />";
					code = code + '</div>';
				}
				if(elements[sid].type === 'data-reach-element'){
					code = code + '<div class="dd-data-reach-element" style="">';
					code = code + "<img src='"+rel_path+"/resources/dd-editor/images/facebook.jpg' style='display:block;margin:0 auto;' />";
					code = code + '</div>';
				}
				if(elements[sid].type === 'video-element'){
					code = code + '<div class="dd-video" style="">';
					code = code + "<img src='"+rel_path+"/resources/dd-editor/images/button-video.png' style='display:block;margin:0 auto;' />";
					code = code + "You can select a video by clicking the gear button above";
					code = code + '</div>';
				}
				
				code = code + "</div></div>";
				/*if(sid < elements.length-1){
					code = code + '<div class="funnelkit-connectors" id="connector-'+con_id+'">Put new section here</div>';
					con_id++;
				}*/
			}
			return code;
		};
		
		self.renderToolbar = function(){
			var available_toolbar_items = [
				'1-coll-element','2-coll-element','3-coll-element',
				'text','text-image-left','text-image-right',
				'image','optin-form','data-reach','video'
			];
			var available_toolbar_labels = [
				'1 column','2 columns','3 columns',
				'text','text with image (left)','text with image (right)',
				'image','optin form','data reach','video & embed code'
			];
			var available_toolbar_hidden = [
				'','','',
				'','','',
				'You can select an image by clicking the gear button above','','','You can select a video by clicking the gear button above'
			];
			var toolbar_items_count = available_toolbar_items.length;
			if(toolbar_items_count>0){
				$(options.tools_container).empty().append('<ul class="tools-item"></ul>');
			}
			for (var i=0;i<toolbar_items_count;i++){
				$(options.tools_container+' .tools-item').append('<li id="tool-'+available_toolbar_items[i]+'" class="tool-'+available_toolbar_items[i]+'" data-hidden="'+available_toolbar_hidden[i]+'">'+available_toolbar_labels[i]+'</li>');
			}
			$(options.tools_container).append('<div class="clear"></div>');
		};
		
		
		self.removeSection = function(section_id){
			if(typeof section_id === 'undefined'){return;}
			var editorObj = $.parseJSON( $('#editor-content').html() );
			if(editorObj === null){return;}
			
			con_id = 0;
			editorObj.childs[0] = self.removeFromSection(editorObj.childs[0], section_id);
			$('#editor-content').html(JSON.stringify(editorObj));
			self.renderEditor();
			self.setupEvents();
			
		};
		
		self.removeFromSection = function(editorObj, section_id){
			var con_len = editorObj.length;
			var temp_editor = [];
			var new_id = 0;
			for (var sid = 0; sid < con_len; sid++){
				if (con_id===section_id){
					con_id++;
				}else{
					con_id++;
					var cot_len = editorObj[sid].childs.length;
					for (var cid = 0; cid < cot_len; cid++){
						editorObj[sid].childs[cid] = self.removeFromSection(editorObj[sid].childs[cid], section_id);	
					}
					temp_editor[new_id]=editorObj[sid];
					new_id++;
				}
			}
			return temp_editor;
		};
		
		
		self.updateSection = function(section_id){
			
			if(typeof section_id === 'undefined'){return;}
			var editorObj = $.parseJSON( $('#editor-content').html() );
			if(editorObj === null){return;}
			
			
			
			con_id = 0;
			editorObj.childs[0] = self.updateFromSection(editorObj.childs[0], section_id);
			
			$('#editor-content').html(JSON.stringify(editorObj));
			self.renderEditor();
			self.setupEvents();
		};
		
		self.updateFromSection = function(editorObj, section_id){
			var con_len = editorObj.length;
			for (var sid = 0; sid < con_len; sid++){
				
				if (con_id===section_id){
					con_id++;
					var form_names = {};
					var form_data_input = jQuery('.active input');
					
					jQuery.each(form_data_input, function(index, fobj){
						form_names[jQuery(fobj).attr('name')] = jQuery(fobj).attr('type');
					});
					
					jQuery.each(form_names, function(name, type){
						if(type==='text'){
							editorObj[sid][name] = jQuery('.active input[name="'+name+'"]').val();
						}
						if(type==='radio'){
							editorObj[sid][name] = jQuery('.active input[name="'+name+'"]:checked').val();
						}
						if(type==='checkbox'){
							if(jQuery('.active input[name="'+name+'"]').attr('checked')==='checked'){
								editorObj[sid][name]='true';
							}else{
								editorObj[sid][name]='false';
							}
						}
					});
					
					var form_data_select = jQuery('.active select');
					jQuery.each(form_data_select, function(index, fobj){
						editorObj[sid][jQuery(fobj).attr('name')] = jQuery('.active select[name="'+jQuery(fobj).attr('name')+'"]').val();
					});
					
					
					if(jQuery('.text-element').hasClass('active')){
						editorObj[sid]['text_element'] = Base64.encode(tinymce.editors['text_element'].getContent());
					}
					
					if(jQuery('.text-image-left-element').hasClass('active')){
						editorObj[sid]['text_image_left_element'] = Base64.encode(tinymce.editors['text_image_left_element'].getContent());
					}
					if(jQuery('.text-image-right-element').hasClass('active')){
						editorObj[sid]['text_image_right_element'] = Base64.encode(tinymce.editors['text_image_right_element'].getContent());
					}

					if(jQuery('.video-element').hasClass('active')){
						editorObj[sid]['coll_video_embed_code'] = Base64.encode(jQuery('.coll_video_embed_code').val());
					}
					
					
				}else{
					con_id++;
					var cot_len = editorObj[sid].childs.length;
					for (var cid = 0; cid < cot_len; cid++){
						editorObj[sid].childs[cid] = self.updateFromSection(editorObj[sid].childs[cid], section_id);	
					}
				}
				
			}
			return editorObj;
		};
		
		self.addItem = function(current_class, connector_id){
			if(typeof connector_id === 'undefined'){return;}
			var editorObj = $.parseJSON( $('#editor-content').html() );
			if(editorObj === null){
				var childs = [];
				childs[0]=[];
				editorObj = {'type':'content','is_container':true, 'childs_count': 1,'childs':childs};
			}
			var positionToInsert = parseInt(connector_id.replace('connector-',''));
			var codeToInsert = self.insertElement(current_class);	
			if(positionToInsert===0){
				editorObj.childs[0].unshift(codeToInsert);
			}else{
				con_id = 1;
				editorObj.childs[0] = self.insertToPosition(editorObj.childs[0], positionToInsert, codeToInsert);
			}
			if(positionToInsert!==0 && con_id===positionToInsert){
				editorObj.childs[0].push(codeToInsert);
			}
			$('#editor-content').html(JSON.stringify(editorObj));
			self.renderEditor();
			self.setupEvents();

		};
		
		self.insertToPosition = function(editorObj, positionToInsert, codeToInsert){
			var con_len = editorObj.length;
			for (var sid = 0; sid < con_len; sid++){
				var cot_len = editorObj[sid].childs.length;
				for (var cid = 0; cid < cot_len; cid++){
					/*alert(cid);*/
					/*if(cid < cot_len-1){
						
						if (positionToInsert === con_id){
							editorObj[sid].childs[cid].unshift(codeToInsert);
						}
						con_id++;
					}*/
					if(editorObj[sid].childs[cid].length===0){
						if (positionToInsert === con_id){
							editorObj[sid].childs[cid].unshift(codeToInsert);
						}
						con_id++;
					}else{
						if(positionToInsert === 1) {
							editorObj[sid].childs[cid].unshift(codeToInsert);
						} else if (positionToInsert === con_id){
							editorObj[sid].childs[cid].push(codeToInsert);
						}
						con_id++;
						editorObj[sid].childs[cid] = self.insertToPosition(editorObj[sid].childs[cid], positionToInsert, codeToInsert);
						if (positionToInsert === con_id){
							editorObj[sid].childs[cid].push(codeToInsert);
						}
						con_id++;
					}

				}
				
			}
			return editorObj;
		};
		
		self.insertElement = function (current_class){
			
			if(current_class === 'tool-1-coll-element'){
				var childs = [];
				childs[0]=[];
				var element = {'type':'1-coll-element','is_container':true, 'childs_count':1 ,'childs':childs,'title':'One column'};
			}
			if(current_class === 'tool-2-coll-element'){
				var childs = [];
				childs[0]=[];
				childs[1]=[];
				var element = {'type':'2-coll-element','is_container':true, 'childs_count':2 ,'childs':childs,'title':'Two columns'};
			}
			
			if(current_class === 'tool-3-coll-element'){
				var childs = [];
				childs[0]=[];
				childs[1]=[];
				childs[2]=[];
				var element = {'type':'3-coll-element','is_container':true, 'childs_count':3 ,'childs':childs,'title':'Three columns'};
			}
			
			if(current_class === 'tool-text'){
				var element = {'type':'text-element','is_container':false, 'childs_count':0 ,'childs':[],'title':'Text', 'text_element':Base64.encode("This is default text. You can change it by clicking the gear icon above.")};
			}
			if(current_class === 'tool-text-image-left'){
				var element = {'type':'text-image-left-element','is_container':false, 'childs_count':0 ,'childs':[],'title':'Text with image left', 'coll_image_url':'', 'text_image_left_element':Base64.encode("This is default text. You can change it by clicking the gear icon above.")};
			}
			if(current_class === 'tool-text-image-right'){
				var element = {'type':'text-image-right-element','is_container':false, 'childs_count':0 ,'childs':[],'title':'Text with image right', 'coll_image_url':'', 'text_image_right_element':Base64.encode("This is default text. You can change it by clicking the gear icon above.")};
			}
			
			if(current_class === 'tool-image'){
				var element = {'type':'image-element','is_container':false, 'childs_count':0 ,'childs':[],'title':'Image', 'coll_image_url':""};
			}

			if(current_class === 'tool-optin-form'){
				var element = {'type':'optin-form-element','is_container':false, 'childs_count':0 ,'childs':[],'title':'Optin form', 'value':""};
			}
			if(current_class === 'tool-data-reach'){
				var element = {'type':'data-reach-element','is_container':false, 'childs_count':0 ,'childs':[],'title':'Data reach', 'value':""};
			}
			if(current_class === 'tool-video'){
				var element = {'type':'video-element','is_container':false, 'childs_count':0 ,'childs':[],'title':'Video & Embed code', 'video':''};
			}

			return element;
		};
		
		(function() {
			
			self.init();
		})();	
	};
	
})(jQuery);